/* FirewallPanel.c generated by valac 0.56.14, the Vala compiler
 * generated from FirewallPanel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2014-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 */

#include "security-privacy.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <granite.h>

enum  {
	SECURITY_PRIVACY_FIREWALL_PANEL_0_PROPERTY,
	SECURITY_PRIVACY_FIREWALL_PANEL_NUM_PROPERTIES
};
static GParamSpec* security_privacy_firewall_panel_properties[SECURITY_PRIVACY_FIREWALL_PANEL_NUM_PROPERTIES];
typedef enum  {
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS
} SecurityPrivacyFirewallPanelColumns;

#define SECURITY_PRIVACY_FIREWALL_PANEL_TYPE_COLUMNS (security_privacy_firewall_panel_columns_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef struct _Block5Data Block5Data;

struct _SecurityPrivacyFirewallPanelPrivate {
	GtkListStore* list_store;
	GtkTreeView* view;
	GtkActionBar* actionbar;
	gboolean loading;
	GtkPopover* add_popover;
	GtkButton* remove_button;
	GSettings* settings;
	GeeHashMap* disabled_rules;
};

struct _Block3Data {
	int _ref_count_;
	SecurityPrivacyFirewallPanel* self;
	SecurityPrivacyUFWHelpersRule* rule;
	gchar* ufw_hash;
};

struct _Block4Data {
	int _ref_count_;
	SecurityPrivacyFirewallPanel* self;
	GtkButton* add_button;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	GtkComboBoxText* policy_combobox;
	GtkComboBoxText* protocol_combobox;
	GtkComboBoxText* version_combobox;
	GtkComboBoxText* direction_combobox;
	GtkEntry* ports_entry;
};

static gint SecurityPrivacyFirewallPanel_private_offset;
static gpointer security_privacy_firewall_panel_parent_class = NULL;

static GType security_privacy_firewall_panel_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void security_privacy_firewall_panel_load_disabled_rules (SecurityPrivacyFirewallPanel* self);
static gchar* security_privacy_firewall_panel_generate_hash_for_rule (SecurityPrivacyFirewallPanel* self,
                                                               SecurityPrivacyUFWHelpersRule* r);
static void security_privacy_firewall_panel_reload_rule_numbers (SecurityPrivacyFirewallPanel* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean ____lambda9_ (Block3Data* _data3_,
                       GtkTreeModel* model,
                       GtkTreePath* path,
                       GtkTreeIter* iter);
static gboolean _____lambda9__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                    GtkTreePath* path,
                                                    GtkTreeIter* iter,
                                                    gpointer self);
static void security_privacy_firewall_panel_show_rules (SecurityPrivacyFirewallPanel* self);
static void security_privacy_firewall_panel_disable_rule (SecurityPrivacyFirewallPanel* self,
                                                   SecurityPrivacyUFWHelpersRule* rule);
static void security_privacy_firewall_panel_save_disabled_rules (SecurityPrivacyFirewallPanel* self,
                                                          SecurityPrivacyUFWHelpersRule* additional_rule);
static void security_privacy_firewall_panel_enable_rule (SecurityPrivacyFirewallPanel* self,
                                                  const gchar* hash);
static void security_privacy_firewall_panel_delete_disabled_rule (SecurityPrivacyFirewallPanel* self,
                                                           const gchar* hash);
static void security_privacy_firewall_panel_create_treeview (SecurityPrivacyFirewallPanel* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda10_ (SecurityPrivacyFirewallPanel* self,
                  const gchar* path);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void ___lambda10__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                                    const gchar* path,
                                                    gpointer self);
static void __lambda11_ (Block4Data* _data4_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda12_ (Block5Data* _data5_);
static void ___lambda12__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void ___lambda11__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda13_ (SecurityPrivacyFirewallPanel* self);
static void ___lambda13__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda14_ (SecurityPrivacyFirewallPanel* self);
static void ___lambda14__gtk_tree_view_cursor_changed (GtkTreeView* _sender,
                                                gpointer self);
static GObject * security_privacy_firewall_panel_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static void _security_privacy_firewall_panel___lambda15_ (SecurityPrivacyFirewallPanel* self);
static void __security_privacy_firewall_panel___lambda15__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void _security_privacy_firewall_panel___lambda16_ (SecurityPrivacyFirewallPanel* self);
static void __security_privacy_firewall_panel___lambda16__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void security_privacy_firewall_panel_finalize (GObject * obj);
static GType security_privacy_firewall_panel_get_type_once (void);

static inline gpointer
security_privacy_firewall_panel_get_instance_private (SecurityPrivacyFirewallPanel* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyFirewallPanel_private_offset);
}

static GType
security_privacy_firewall_panel_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION", "action"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL", "protocol"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION", "direction"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO", "to"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM", "from"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6", "v6"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED", "enabled"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE", "rule"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
	GType security_privacy_firewall_panel_columns_type_id;
	security_privacy_firewall_panel_columns_type_id = g_enum_register_static ("SecurityPrivacyFirewallPanelColumns", values);
	return security_privacy_firewall_panel_columns_type_id;
}

static GType
security_privacy_firewall_panel_columns_get_type (void)
{
	static volatile gsize security_privacy_firewall_panel_columns_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_firewall_panel_columns_type_id__once)) {
		GType security_privacy_firewall_panel_columns_type_id;
		security_privacy_firewall_panel_columns_type_id = security_privacy_firewall_panel_columns_get_type_once ();
		g_once_init_leave (&security_privacy_firewall_panel_columns_type_id__once, security_privacy_firewall_panel_columns_type_id);
	}
	return security_privacy_firewall_panel_columns_type_id__once;
}

SecurityPrivacyFirewallPanel*
security_privacy_firewall_panel_construct (GType object_type)
{
	SecurityPrivacyFirewallPanel * self = NULL;
#line 46 "../src/Views/FirewallPanel.vala"
	self = (SecurityPrivacyFirewallPanel*) g_object_new (object_type, "activatable", TRUE, "icon-name", "network-firewall", "title", _ ("Firewall"), NULL);
#line 45 "../src/Views/FirewallPanel.vala"
	return self;
#line 203 "FirewallPanel.c"
}

SecurityPrivacyFirewallPanel*
security_privacy_firewall_panel_new (void)
{
#line 45 "../src/Views/FirewallPanel.vala"
	return security_privacy_firewall_panel_construct (SECURITY_PRIVACY_TYPE_FIREWALL_PANEL);
#line 211 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_load_disabled_rules (SecurityPrivacyFirewallPanel* self)
{
	GeeHashMap* _tmp0_;
	gchar* to = NULL;
	gchar* _tmp1_;
	gchar* to_ports = NULL;
	gchar* _tmp2_;
	gchar* from = NULL;
	gchar* _tmp3_;
	gchar* from_ports = NULL;
	gchar* _tmp4_;
	gint action = 0;
	gint protocol = 0;
	gint direction = 0;
	gint version = 0;
	GVariant* rules = NULL;
	GSettings* _tmp5_;
	GVariant* _tmp6_;
	GVariantIter* iter = NULL;
	GVariant* _tmp7_;
	GVariantIter* _tmp8_;
#line 94 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/Views/FirewallPanel.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 95 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->disabled_rules);
#line 95 "../src/Views/FirewallPanel.vala"
	self->priv->disabled_rules = _tmp0_;
#line 96 "../src/Views/FirewallPanel.vala"
	_tmp1_ = g_strdup ("");
#line 96 "../src/Views/FirewallPanel.vala"
	to = _tmp1_;
#line 96 "../src/Views/FirewallPanel.vala"
	_tmp2_ = g_strdup ("");
#line 96 "../src/Views/FirewallPanel.vala"
	to_ports = _tmp2_;
#line 96 "../src/Views/FirewallPanel.vala"
	_tmp3_ = g_strdup ("");
#line 96 "../src/Views/FirewallPanel.vala"
	from = _tmp3_;
#line 96 "../src/Views/FirewallPanel.vala"
	_tmp4_ = g_strdup ("");
#line 96 "../src/Views/FirewallPanel.vala"
	from_ports = _tmp4_;
#line 97 "../src/Views/FirewallPanel.vala"
	action = 0;
#line 97 "../src/Views/FirewallPanel.vala"
	protocol = 0;
#line 97 "../src/Views/FirewallPanel.vala"
	direction = 0;
#line 97 "../src/Views/FirewallPanel.vala"
	version = 0;
#line 98 "../src/Views/FirewallPanel.vala"
	_tmp5_ = self->priv->settings;
#line 98 "../src/Views/FirewallPanel.vala"
	_tmp6_ = g_settings_get_value (_tmp5_, "disabled-firewall-rules");
#line 98 "../src/Views/FirewallPanel.vala"
	rules = _tmp6_;
#line 99 "../src/Views/FirewallPanel.vala"
	_tmp7_ = rules;
#line 99 "../src/Views/FirewallPanel.vala"
	_tmp8_ = g_variant_iter_new (_tmp7_);
#line 99 "../src/Views/FirewallPanel.vala"
	iter = _tmp8_;
#line 100 "../src/Views/FirewallPanel.vala"
	while (TRUE) {
#line 282 "FirewallPanel.c"
		GVariantIter* _tmp9_;
		gboolean _tmp10_;
		SecurityPrivacyUFWHelpersRule* new_rule = NULL;
		SecurityPrivacyUFWHelpersRule* _tmp11_;
		SecurityPrivacyUFWHelpersRule* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		SecurityPrivacyUFWHelpersRule* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		SecurityPrivacyUFWHelpersRule* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		SecurityPrivacyUFWHelpersRule* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		SecurityPrivacyUFWHelpersRule* _tmp24_;
		SecurityPrivacyUFWHelpersRule* _tmp25_;
		SecurityPrivacyUFWHelpersRule* _tmp26_;
		SecurityPrivacyUFWHelpersRule* _tmp27_;
		gchar* hash = NULL;
		SecurityPrivacyUFWHelpersRule* _tmp28_;
		gchar* _tmp29_;
		GeeHashMap* _tmp30_;
		const gchar* _tmp31_;
		SecurityPrivacyUFWHelpersRule* _tmp32_;
#line 100 "../src/Views/FirewallPanel.vala"
		_tmp9_ = iter;
#line 100 "../src/Views/FirewallPanel.vala"
		_tmp10_ = g_variant_iter_next (_tmp9_, "(ssssiiii)", &to, &to_ports, &from, &from_ports, &action, &protocol, &direction, &version, NULL);
#line 100 "../src/Views/FirewallPanel.vala"
		if (!_tmp10_) {
#line 100 "../src/Views/FirewallPanel.vala"
			break;
#line 317 "FirewallPanel.c"
		}
#line 111 "../src/Views/FirewallPanel.vala"
		_tmp11_ = security_privacy_ufw_helpers_rule_new ();
#line 111 "../src/Views/FirewallPanel.vala"
		new_rule = _tmp11_;
#line 112 "../src/Views/FirewallPanel.vala"
		_tmp12_ = new_rule;
#line 112 "../src/Views/FirewallPanel.vala"
		_tmp13_ = to;
#line 112 "../src/Views/FirewallPanel.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 112 "../src/Views/FirewallPanel.vala"
		_g_free0 (_tmp12_->to);
#line 112 "../src/Views/FirewallPanel.vala"
		_tmp12_->to = _tmp14_;
#line 113 "../src/Views/FirewallPanel.vala"
		_tmp15_ = new_rule;
#line 113 "../src/Views/FirewallPanel.vala"
		_tmp16_ = to_ports;
#line 113 "../src/Views/FirewallPanel.vala"
		_tmp17_ = g_strdup (_tmp16_);
#line 113 "../src/Views/FirewallPanel.vala"
		_g_free0 (_tmp15_->to_ports);
#line 113 "../src/Views/FirewallPanel.vala"
		_tmp15_->to_ports = _tmp17_;
#line 114 "../src/Views/FirewallPanel.vala"
		_tmp18_ = new_rule;
#line 114 "../src/Views/FirewallPanel.vala"
		_tmp19_ = from;
#line 114 "../src/Views/FirewallPanel.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 114 "../src/Views/FirewallPanel.vala"
		_g_free0 (_tmp18_->from);
#line 114 "../src/Views/FirewallPanel.vala"
		_tmp18_->from = _tmp20_;
#line 115 "../src/Views/FirewallPanel.vala"
		_tmp21_ = new_rule;
#line 115 "../src/Views/FirewallPanel.vala"
		_tmp22_ = from_ports;
#line 115 "../src/Views/FirewallPanel.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 115 "../src/Views/FirewallPanel.vala"
		_g_free0 (_tmp21_->from_ports);
#line 115 "../src/Views/FirewallPanel.vala"
		_tmp21_->from_ports = _tmp23_;
#line 116 "../src/Views/FirewallPanel.vala"
		_tmp24_ = new_rule;
#line 116 "../src/Views/FirewallPanel.vala"
		_tmp24_->action = (SecurityPrivacyUFWHelpersRuleAction) action;
#line 117 "../src/Views/FirewallPanel.vala"
		_tmp25_ = new_rule;
#line 117 "../src/Views/FirewallPanel.vala"
		_tmp25_->protocol = (SecurityPrivacyUFWHelpersRuleProtocol) protocol;
#line 118 "../src/Views/FirewallPanel.vala"
		_tmp26_ = new_rule;
#line 118 "../src/Views/FirewallPanel.vala"
		_tmp26_->direction = (SecurityPrivacyUFWHelpersRuleDirection) direction;
#line 119 "../src/Views/FirewallPanel.vala"
		_tmp27_ = new_rule;
#line 119 "../src/Views/FirewallPanel.vala"
		_tmp27_->version = (SecurityPrivacyUFWHelpersRuleVersion) version;
#line 120 "../src/Views/FirewallPanel.vala"
		_tmp28_ = new_rule;
#line 120 "../src/Views/FirewallPanel.vala"
		_tmp29_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp28_);
#line 120 "../src/Views/FirewallPanel.vala"
		hash = _tmp29_;
#line 121 "../src/Views/FirewallPanel.vala"
		_tmp30_ = self->priv->disabled_rules;
#line 121 "../src/Views/FirewallPanel.vala"
		_tmp31_ = hash;
#line 121 "../src/Views/FirewallPanel.vala"
		_tmp32_ = new_rule;
#line 121 "../src/Views/FirewallPanel.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, _tmp31_, _tmp32_);
#line 100 "../src/Views/FirewallPanel.vala"
		_g_free0 (hash);
#line 100 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (new_rule);
#line 397 "FirewallPanel.c"
	}
#line 94 "../src/Views/FirewallPanel.vala"
	_g_variant_iter_free0 (iter);
#line 94 "../src/Views/FirewallPanel.vala"
	_g_variant_unref0 (rules);
#line 94 "../src/Views/FirewallPanel.vala"
	_g_free0 (from_ports);
#line 94 "../src/Views/FirewallPanel.vala"
	_g_free0 (from);
#line 94 "../src/Views/FirewallPanel.vala"
	_g_free0 (to_ports);
#line 94 "../src/Views/FirewallPanel.vala"
	_g_free0 (to);
#line 411 "FirewallPanel.c"
}

static gchar*
security_privacy_firewall_panel_generate_hash_for_rule (SecurityPrivacyFirewallPanel* self,
                                                        SecurityPrivacyUFWHelpersRule* r)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GEnumValue* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GEnumValue* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GEnumValue* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GEnumValue* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* result;
#line 125 "../src/Views/FirewallPanel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "../src/Views/FirewallPanel.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp0_ = r->to;
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp1_ = r->to_ports;
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp2_ = g_strconcat (_tmp0_, _tmp1_, NULL);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp3_ = _tmp2_;
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp4_ = r->from;
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp5_ = g_strconcat (_tmp3_, _tmp4_, NULL);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp6_ = _tmp5_;
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp7_ = r->from_ports;
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp9_ = _tmp8_;
#line 130 "../src/Views/FirewallPanel.vala"
	_tmp10_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_ACTION), r->action);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp11_ = g_strconcat (_tmp9_, (_tmp10_ != NULL) ? _tmp10_->value_name : NULL, NULL);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp12_ = _tmp11_;
#line 131 "../src/Views/FirewallPanel.vala"
	_tmp13_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_PROTOCOL), r->protocol);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp14_ = g_strconcat (_tmp12_, (_tmp13_ != NULL) ? _tmp13_->value_name : NULL, NULL);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp15_ = _tmp14_;
#line 132 "../src/Views/FirewallPanel.vala"
	_tmp16_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_DIRECTION), r->direction);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp17_ = g_strconcat (_tmp15_, (_tmp16_ != NULL) ? _tmp16_->value_name : NULL, NULL);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp18_ = _tmp17_;
#line 133 "../src/Views/FirewallPanel.vala"
	_tmp19_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_VERSION), r->version);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp20_ = g_strconcat (_tmp18_, (_tmp19_ != NULL) ? _tmp19_->value_name : NULL, NULL);
#line 126 "../src/Views/FirewallPanel.vala"
	_tmp21_ = _tmp20_;
#line 126 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp18_);
#line 126 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp15_);
#line 126 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp12_);
#line 126 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp9_);
#line 126 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp6_);
#line 126 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp3_);
#line 126 "../src/Views/FirewallPanel.vala"
	result = _tmp21_;
#line 126 "../src/Views/FirewallPanel.vala"
	return result;
#line 505 "FirewallPanel.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 137 "../src/Views/FirewallPanel.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 137 "../src/Views/FirewallPanel.vala"
	return _data3_;
#line 515 "FirewallPanel.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 137 "../src/Views/FirewallPanel.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 525 "FirewallPanel.c"
		SecurityPrivacyFirewallPanel* self;
#line 137 "../src/Views/FirewallPanel.vala"
		self = _data3_->self;
#line 137 "../src/Views/FirewallPanel.vala"
		_g_free0 (_data3_->ufw_hash);
#line 137 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data3_->rule);
#line 137 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (self);
#line 137 "../src/Views/FirewallPanel.vala"
		g_slice_free (Block3Data, _data3_);
#line 537 "FirewallPanel.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 143 "../src/Views/FirewallPanel.vala"
	return self ? g_object_ref (self) : NULL;
#line 546 "FirewallPanel.c"
}

static gboolean
____lambda9_ (Block3Data* _data3_,
              GtkTreeModel* model,
              GtkTreePath* path,
              GtkTreeIter* iter)
{
	SecurityPrivacyFirewallPanel* self;
	GValue val = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GValue _tmp2_ = {0};
	SecurityPrivacyUFWHelpersRule* tree_rule = NULL;
	GValue _tmp3_;
	SecurityPrivacyUFWHelpersRule* _tmp4_;
	gchar* tree_hash = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gboolean result;
#line 139 "../src/Views/FirewallPanel.vala"
	self = _data3_->self;
#line 139 "../src/Views/FirewallPanel.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 139 "../src/Views/FirewallPanel.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 139 "../src/Views/FirewallPanel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 142 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->list_store;
#line 142 "../src/Views/FirewallPanel.vala"
	_tmp1_ = *iter;
#line 142 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp0_, &_tmp1_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp2_);
#line 142 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 142 "../src/Views/FirewallPanel.vala"
	val = _tmp2_;
#line 143 "../src/Views/FirewallPanel.vala"
	_tmp3_ = val;
#line 143 "../src/Views/FirewallPanel.vala"
	_tmp4_ = _g_object_ref0 (g_value_get_object (&_tmp3_));
#line 143 "../src/Views/FirewallPanel.vala"
	tree_rule = _tmp4_;
#line 144 "../src/Views/FirewallPanel.vala"
	_tmp5_ = tree_rule;
#line 144 "../src/Views/FirewallPanel.vala"
	_tmp6_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp5_);
#line 144 "../src/Views/FirewallPanel.vala"
	tree_hash = _tmp6_;
#line 145 "../src/Views/FirewallPanel.vala"
	_tmp7_ = _data3_->ufw_hash;
#line 145 "../src/Views/FirewallPanel.vala"
	_tmp8_ = tree_hash;
#line 145 "../src/Views/FirewallPanel.vala"
	if (g_strcmp0 (_tmp7_, _tmp8_) == 0) {
#line 605 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp9_;
		SecurityPrivacyUFWHelpersRule* _tmp10_;
		GtkListStore* _tmp11_;
		GtkTreeIter _tmp12_;
		SecurityPrivacyUFWHelpersRule* _tmp13_;
		GValue _tmp14_ = {0};
#line 146 "../src/Views/FirewallPanel.vala"
		_tmp9_ = tree_rule;
#line 146 "../src/Views/FirewallPanel.vala"
		_tmp10_ = _data3_->rule;
#line 146 "../src/Views/FirewallPanel.vala"
		_tmp9_->number = _tmp10_->number;
#line 147 "../src/Views/FirewallPanel.vala"
		_tmp11_ = self->priv->list_store;
#line 147 "../src/Views/FirewallPanel.vala"
		_tmp12_ = *iter;
#line 147 "../src/Views/FirewallPanel.vala"
		_tmp13_ = tree_rule;
#line 147 "../src/Views/FirewallPanel.vala"
		g_value_init (&_tmp14_, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE);
#line 147 "../src/Views/FirewallPanel.vala"
		g_value_set_object (&_tmp14_, _tmp13_);
#line 147 "../src/Views/FirewallPanel.vala"
		gtk_list_store_set_value (_tmp11_, &_tmp12_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp14_);
#line 147 "../src/Views/FirewallPanel.vala"
		G_IS_VALUE (&_tmp14_) ? (g_value_unset (&_tmp14_), NULL) : NULL;
#line 148 "../src/Views/FirewallPanel.vala"
		result = TRUE;
#line 148 "../src/Views/FirewallPanel.vala"
		_g_free0 (tree_hash);
#line 148 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (tree_rule);
#line 148 "../src/Views/FirewallPanel.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 148 "../src/Views/FirewallPanel.vala"
		return result;
#line 642 "FirewallPanel.c"
	}
#line 151 "../src/Views/FirewallPanel.vala"
	result = FALSE;
#line 151 "../src/Views/FirewallPanel.vala"
	_g_free0 (tree_hash);
#line 151 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (tree_rule);
#line 151 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 151 "../src/Views/FirewallPanel.vala"
	return result;
#line 654 "FirewallPanel.c"
}

static gboolean
_____lambda9__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                           GtkTreePath* path,
                                           GtkTreeIter* iter,
                                           gpointer self)
{
	gboolean result;
	result = ____lambda9_ (self, model, path, iter);
#line 139 "../src/Views/FirewallPanel.vala"
	return result;
#line 667 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_reload_rule_numbers (SecurityPrivacyFirewallPanel* self)
{
#line 136 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 675 "FirewallPanel.c"
	{
		GeeLinkedList* _rule_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _rule_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _rule_index = 0;
#line 137 "../src/Views/FirewallPanel.vala"
		_tmp0_ = security_privacy_ufw_helpers_get_rules ();
#line 137 "../src/Views/FirewallPanel.vala"
		_rule_list = _tmp0_;
#line 137 "../src/Views/FirewallPanel.vala"
		_tmp1_ = _rule_list;
#line 137 "../src/Views/FirewallPanel.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 137 "../src/Views/FirewallPanel.vala"
		_tmp3_ = _tmp2_;
#line 137 "../src/Views/FirewallPanel.vala"
		_rule_size = _tmp3_;
#line 137 "../src/Views/FirewallPanel.vala"
		_rule_index = -1;
#line 137 "../src/Views/FirewallPanel.vala"
		while (TRUE) {
#line 700 "FirewallPanel.c"
			Block3Data* _data3_;
			gint _tmp4_;
			gint _tmp5_;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			SecurityPrivacyUFWHelpersRule* _tmp8_;
			gchar* _tmp9_;
			GtkTreeModelForeachFunc update_row = NULL;
			gpointer update_row_target;
			GDestroyNotify update_row_target_destroy_notify;
			GtkListStore* _tmp10_;
			GtkTreeModelForeachFunc _tmp11_;
			gpointer _tmp11__target;
#line 137 "../src/Views/FirewallPanel.vala"
			_data3_ = g_slice_new0 (Block3Data);
#line 137 "../src/Views/FirewallPanel.vala"
			_data3_->_ref_count_ = 1;
#line 137 "../src/Views/FirewallPanel.vala"
			_data3_->self = g_object_ref (self);
#line 137 "../src/Views/FirewallPanel.vala"
			_rule_index = _rule_index + 1;
#line 137 "../src/Views/FirewallPanel.vala"
			_tmp4_ = _rule_index;
#line 137 "../src/Views/FirewallPanel.vala"
			_tmp5_ = _rule_size;
#line 137 "../src/Views/FirewallPanel.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 137 "../src/Views/FirewallPanel.vala"
				block3_data_unref (_data3_);
#line 137 "../src/Views/FirewallPanel.vala"
				_data3_ = NULL;
#line 137 "../src/Views/FirewallPanel.vala"
				break;
#line 734 "FirewallPanel.c"
			}
#line 137 "../src/Views/FirewallPanel.vala"
			_tmp6_ = _rule_list;
#line 137 "../src/Views/FirewallPanel.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _rule_index);
#line 137 "../src/Views/FirewallPanel.vala"
			_data3_->rule = (SecurityPrivacyUFWHelpersRule*) _tmp7_;
#line 138 "../src/Views/FirewallPanel.vala"
			_tmp8_ = _data3_->rule;
#line 138 "../src/Views/FirewallPanel.vala"
			_tmp9_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp8_);
#line 138 "../src/Views/FirewallPanel.vala"
			_data3_->ufw_hash = _tmp9_;
#line 139 "../src/Views/FirewallPanel.vala"
			update_row = _____lambda9__gtk_tree_model_foreach_func;
#line 139 "../src/Views/FirewallPanel.vala"
			update_row_target = block3_data_ref (_data3_);
#line 139 "../src/Views/FirewallPanel.vala"
			update_row_target_destroy_notify = block3_data_unref;
#line 153 "../src/Views/FirewallPanel.vala"
			_tmp10_ = self->priv->list_store;
#line 153 "../src/Views/FirewallPanel.vala"
			_tmp11_ = update_row;
#line 153 "../src/Views/FirewallPanel.vala"
			_tmp11__target = update_row_target;
#line 153 "../src/Views/FirewallPanel.vala"
			gtk_tree_model_foreach ((GtkTreeModel*) _tmp10_, _tmp11_, _tmp11__target);
#line 137 "../src/Views/FirewallPanel.vala"
			(update_row_target_destroy_notify == NULL) ? NULL : (update_row_target_destroy_notify (update_row_target), NULL);
#line 137 "../src/Views/FirewallPanel.vala"
			update_row = NULL;
#line 137 "../src/Views/FirewallPanel.vala"
			update_row_target = NULL;
#line 137 "../src/Views/FirewallPanel.vala"
			update_row_target_destroy_notify = NULL;
#line 137 "../src/Views/FirewallPanel.vala"
			block3_data_unref (_data3_);
#line 137 "../src/Views/FirewallPanel.vala"
			_data3_ = NULL;
#line 774 "FirewallPanel.c"
		}
#line 137 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_rule_list);
#line 778 "FirewallPanel.c"
	}
}

static void
security_privacy_firewall_panel_show_rules (SecurityPrivacyFirewallPanel* self)
{
	GtkListStore* _tmp0_;
	GtkButton* _tmp1_;
#line 157 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->list_store;
#line 158 "../src/Views/FirewallPanel.vala"
	gtk_list_store_clear (_tmp0_);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp1_ = self->priv->remove_button;
#line 159 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 797 "FirewallPanel.c"
	{
		GeeLinkedList* _rule_list = NULL;
		GeeLinkedList* _tmp2_;
		gint _rule_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _rule_index = 0;
#line 160 "../src/Views/FirewallPanel.vala"
		_tmp2_ = security_privacy_ufw_helpers_get_rules ();
#line 160 "../src/Views/FirewallPanel.vala"
		_rule_list = _tmp2_;
#line 160 "../src/Views/FirewallPanel.vala"
		_tmp3_ = _rule_list;
#line 160 "../src/Views/FirewallPanel.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 160 "../src/Views/FirewallPanel.vala"
		_tmp5_ = _tmp4_;
#line 160 "../src/Views/FirewallPanel.vala"
		_rule_size = _tmp5_;
#line 160 "../src/Views/FirewallPanel.vala"
		_rule_index = -1;
#line 160 "../src/Views/FirewallPanel.vala"
		while (TRUE) {
#line 822 "FirewallPanel.c"
			gint _tmp6_;
			gint _tmp7_;
			SecurityPrivacyUFWHelpersRule* rule = NULL;
			GeeLinkedList* _tmp8_;
			gpointer _tmp9_;
			SecurityPrivacyUFWHelpersRule* _tmp10_;
#line 160 "../src/Views/FirewallPanel.vala"
			_rule_index = _rule_index + 1;
#line 160 "../src/Views/FirewallPanel.vala"
			_tmp6_ = _rule_index;
#line 160 "../src/Views/FirewallPanel.vala"
			_tmp7_ = _rule_size;
#line 160 "../src/Views/FirewallPanel.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 160 "../src/Views/FirewallPanel.vala"
				break;
#line 839 "FirewallPanel.c"
			}
#line 160 "../src/Views/FirewallPanel.vala"
			_tmp8_ = _rule_list;
#line 160 "../src/Views/FirewallPanel.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _rule_index);
#line 160 "../src/Views/FirewallPanel.vala"
			rule = (SecurityPrivacyUFWHelpersRule*) _tmp9_;
#line 161 "../src/Views/FirewallPanel.vala"
			_tmp10_ = rule;
#line 161 "../src/Views/FirewallPanel.vala"
			security_privacy_firewall_panel_add_rule (self, _tmp10_, TRUE, "");
#line 160 "../src/Views/FirewallPanel.vala"
			_g_object_unref0 (rule);
#line 853 "FirewallPanel.c"
		}
#line 160 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_rule_list);
#line 857 "FirewallPanel.c"
	}
#line 164 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_load_disabled_rules (self);
#line 861 "FirewallPanel.c"
	{
		GeeIterator* _rule_it = NULL;
		GeeHashMap* _tmp11_;
		GeeSet* _tmp12_;
		GeeSet* _tmp13_;
		GeeSet* _tmp14_;
		GeeIterator* _tmp15_;
		GeeIterator* _tmp16_;
#line 165 "../src/Views/FirewallPanel.vala"
		_tmp11_ = self->priv->disabled_rules;
#line 165 "../src/Views/FirewallPanel.vala"
		_tmp12_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp11_);
#line 165 "../src/Views/FirewallPanel.vala"
		_tmp13_ = _tmp12_;
#line 165 "../src/Views/FirewallPanel.vala"
		_tmp14_ = _tmp13_;
#line 165 "../src/Views/FirewallPanel.vala"
		_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 165 "../src/Views/FirewallPanel.vala"
		_tmp16_ = _tmp15_;
#line 165 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_tmp14_);
#line 165 "../src/Views/FirewallPanel.vala"
		_rule_it = _tmp16_;
#line 165 "../src/Views/FirewallPanel.vala"
		while (TRUE) {
#line 888 "FirewallPanel.c"
			GeeIterator* _tmp17_;
			GeeMapEntry* rule = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			GeeMapEntry* _tmp20_;
			gconstpointer _tmp21_;
			gconstpointer _tmp22_;
			GeeMapEntry* _tmp23_;
			gconstpointer _tmp24_;
			gconstpointer _tmp25_;
#line 165 "../src/Views/FirewallPanel.vala"
			_tmp17_ = _rule_it;
#line 165 "../src/Views/FirewallPanel.vala"
			if (!gee_iterator_next (_tmp17_)) {
#line 165 "../src/Views/FirewallPanel.vala"
				break;
#line 905 "FirewallPanel.c"
			}
#line 165 "../src/Views/FirewallPanel.vala"
			_tmp18_ = _rule_it;
#line 165 "../src/Views/FirewallPanel.vala"
			_tmp19_ = gee_iterator_get (_tmp18_);
#line 165 "../src/Views/FirewallPanel.vala"
			rule = (GeeMapEntry*) _tmp19_;
#line 166 "../src/Views/FirewallPanel.vala"
			_tmp20_ = rule;
#line 166 "../src/Views/FirewallPanel.vala"
			_tmp21_ = gee_map_entry_get_value (_tmp20_);
#line 166 "../src/Views/FirewallPanel.vala"
			_tmp22_ = _tmp21_;
#line 166 "../src/Views/FirewallPanel.vala"
			_tmp23_ = rule;
#line 166 "../src/Views/FirewallPanel.vala"
			_tmp24_ = gee_map_entry_get_key (_tmp23_);
#line 166 "../src/Views/FirewallPanel.vala"
			_tmp25_ = _tmp24_;
#line 166 "../src/Views/FirewallPanel.vala"
			security_privacy_firewall_panel_add_rule (self, (SecurityPrivacyUFWHelpersRule*) _tmp22_, FALSE, (const gchar*) _tmp25_);
#line 165 "../src/Views/FirewallPanel.vala"
			_g_object_unref0 (rule);
#line 929 "FirewallPanel.c"
		}
#line 165 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_rule_it);
#line 933 "FirewallPanel.c"
	}
}

static void
security_privacy_firewall_panel_disable_rule (SecurityPrivacyFirewallPanel* self,
                                              SecurityPrivacyUFWHelpersRule* rule)
{
#line 170 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (rule != NULL);
#line 171 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_save_disabled_rules (self, rule);
#line 172 "../src/Views/FirewallPanel.vala"
	security_privacy_ufw_helpers_remove_rule (rule);
#line 949 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_enable_rule (SecurityPrivacyFirewallPanel* self,
                                             const gchar* hash)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	SecurityPrivacyUFWHelpersRule* _tmp2_;
#line 175 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (hash != NULL);
#line 176 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->disabled_rules;
#line 176 "../src/Views/FirewallPanel.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, hash);
#line 176 "../src/Views/FirewallPanel.vala"
	_tmp2_ = (SecurityPrivacyUFWHelpersRule*) _tmp1_;
#line 176 "../src/Views/FirewallPanel.vala"
	security_privacy_ufw_helpers_add_rule (_tmp2_);
#line 176 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp2_);
#line 177 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_delete_disabled_rule (self, hash);
#line 975 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_delete_disabled_rule (SecurityPrivacyFirewallPanel* self,
                                                      const gchar* hash)
{
	GeeHashMap* _tmp0_;
#line 180 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (hash != NULL);
#line 181 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->disabled_rules;
#line 181 "../src/Views/FirewallPanel.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, hash, NULL);
#line 182 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_save_disabled_rules (self, NULL);
#line 993 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_save_disabled_rules (SecurityPrivacyFirewallPanel* self,
                                                     SecurityPrivacyUFWHelpersRule* additional_rule)
{
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	GSettings* _tmp31_;
	GVariantBuilder* _tmp32_;
	GVariant* _tmp33_;
	GVariant* _tmp34_;
#line 185 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/Views/FirewallPanel.vala"
	_tmp0_ = g_variant_type_new ("a(ssssiiii)");
#line 186 "../src/Views/FirewallPanel.vala"
	_tmp1_ = _tmp0_;
#line 186 "../src/Views/FirewallPanel.vala"
	_tmp2_ = g_variant_builder_new (_tmp1_);
#line 186 "../src/Views/FirewallPanel.vala"
	_tmp3_ = _tmp2_;
#line 186 "../src/Views/FirewallPanel.vala"
	_g_variant_type_free0 (_tmp1_);
#line 186 "../src/Views/FirewallPanel.vala"
	builder = _tmp3_;
#line 1023 "FirewallPanel.c"
	{
		GeeIterator* _existing_rule_it = NULL;
		GeeHashMap* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		GeeIterator* _tmp8_;
		GeeIterator* _tmp9_;
#line 187 "../src/Views/FirewallPanel.vala"
		_tmp4_ = self->priv->disabled_rules;
#line 187 "../src/Views/FirewallPanel.vala"
		_tmp5_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp4_);
#line 187 "../src/Views/FirewallPanel.vala"
		_tmp6_ = _tmp5_;
#line 187 "../src/Views/FirewallPanel.vala"
		_tmp7_ = _tmp6_;
#line 187 "../src/Views/FirewallPanel.vala"
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 187 "../src/Views/FirewallPanel.vala"
		_tmp9_ = _tmp8_;
#line 187 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_tmp7_);
#line 187 "../src/Views/FirewallPanel.vala"
		_existing_rule_it = _tmp9_;
#line 187 "../src/Views/FirewallPanel.vala"
		while (TRUE) {
#line 1050 "FirewallPanel.c"
			GeeIterator* _tmp10_;
			SecurityPrivacyUFWHelpersRule* existing_rule = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			GVariantBuilder* _tmp13_;
			SecurityPrivacyUFWHelpersRule* _tmp14_;
			const gchar* _tmp15_;
			SecurityPrivacyUFWHelpersRule* _tmp16_;
			const gchar* _tmp17_;
			SecurityPrivacyUFWHelpersRule* _tmp18_;
			const gchar* _tmp19_;
			SecurityPrivacyUFWHelpersRule* _tmp20_;
			const gchar* _tmp21_;
			SecurityPrivacyUFWHelpersRule* _tmp22_;
			SecurityPrivacyUFWHelpersRule* _tmp23_;
			SecurityPrivacyUFWHelpersRule* _tmp24_;
			SecurityPrivacyUFWHelpersRule* _tmp25_;
#line 187 "../src/Views/FirewallPanel.vala"
			_tmp10_ = _existing_rule_it;
#line 187 "../src/Views/FirewallPanel.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 187 "../src/Views/FirewallPanel.vala"
				break;
#line 1074 "FirewallPanel.c"
			}
#line 187 "../src/Views/FirewallPanel.vala"
			_tmp11_ = _existing_rule_it;
#line 187 "../src/Views/FirewallPanel.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 187 "../src/Views/FirewallPanel.vala"
			existing_rule = (SecurityPrivacyUFWHelpersRule*) _tmp12_;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp13_ = builder;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp14_ = existing_rule;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp15_ = _tmp14_->to;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp16_ = existing_rule;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp17_ = _tmp16_->to_ports;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp18_ = existing_rule;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp19_ = _tmp18_->from;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp20_ = existing_rule;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp21_ = _tmp20_->from_ports;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp22_ = existing_rule;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp23_ = existing_rule;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp24_ = existing_rule;
#line 188 "../src/Views/FirewallPanel.vala"
			_tmp25_ = existing_rule;
#line 188 "../src/Views/FirewallPanel.vala"
			g_variant_builder_add (_tmp13_, "(ssssiiii)", _tmp15_, _tmp17_, _tmp19_, _tmp21_, _tmp22_->action, _tmp23_->protocol, _tmp24_->direction, _tmp25_->version, NULL);
#line 187 "../src/Views/FirewallPanel.vala"
			_g_object_unref0 (existing_rule);
#line 1112 "FirewallPanel.c"
		}
#line 187 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_existing_rule_it);
#line 1116 "FirewallPanel.c"
	}
#line 197 "../src/Views/FirewallPanel.vala"
	if (additional_rule != NULL) {
#line 1120 "FirewallPanel.c"
		GVariantBuilder* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp26_ = builder;
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp27_ = additional_rule->to;
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp28_ = additional_rule->to_ports;
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp29_ = additional_rule->from;
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp30_ = additional_rule->from_ports;
#line 198 "../src/Views/FirewallPanel.vala"
		g_variant_builder_add (_tmp26_, "(ssssiiii)", _tmp27_, _tmp28_, _tmp29_, _tmp30_, additional_rule->action, additional_rule->protocol, additional_rule->direction, additional_rule->version, NULL);
#line 1138 "FirewallPanel.c"
	}
#line 207 "../src/Views/FirewallPanel.vala"
	_tmp31_ = self->priv->settings;
#line 207 "../src/Views/FirewallPanel.vala"
	_tmp32_ = builder;
#line 207 "../src/Views/FirewallPanel.vala"
	_tmp33_ = g_variant_builder_end (_tmp32_);
#line 207 "../src/Views/FirewallPanel.vala"
	g_variant_ref_sink (_tmp33_);
#line 207 "../src/Views/FirewallPanel.vala"
	_tmp34_ = _tmp33_;
#line 207 "../src/Views/FirewallPanel.vala"
	g_settings_set_value (_tmp31_, "disabled-firewall-rules", _tmp34_);
#line 207 "../src/Views/FirewallPanel.vala"
	_g_variant_unref0 (_tmp34_);
#line 208 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_load_disabled_rules (self);
#line 185 "../src/Views/FirewallPanel.vala"
	_g_variant_builder_unref0 (builder);
#line 1158 "FirewallPanel.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 1177 "FirewallPanel.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1199 "FirewallPanel.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1203 "FirewallPanel.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1209 "FirewallPanel.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1213 "FirewallPanel.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1217 "FirewallPanel.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 1225 "FirewallPanel.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1253 "FirewallPanel.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 1262 "FirewallPanel.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1276 "FirewallPanel.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 1285 "FirewallPanel.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 1299 "FirewallPanel.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1308 "FirewallPanel.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 1317 "FirewallPanel.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 1338 "FirewallPanel.c"
}

void
security_privacy_firewall_panel_add_rule (SecurityPrivacyFirewallPanel* self,
                                          SecurityPrivacyUFWHelpersRule* rule,
                                          gboolean enabled,
                                          const gchar* hash)
{
	GtkTreeIter iter = {0};
	gchar* action = NULL;
	gchar* _tmp0_;
	gchar* protocol = NULL;
	gchar* _tmp5_;
	gchar* direction = NULL;
	gchar* _tmp9_;
	gchar* version = NULL;
	gchar* _tmp12_;
	gchar* from = NULL;
	gchar* _tmp15_;
	gchar* to = NULL;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp33_;
	GtkListStore* _tmp49_;
	GtkTreeIter _tmp50_ = {0};
	GtkListStore* _tmp51_;
	GtkTreeIter _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
#line 211 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (rule != NULL);
#line 211 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (hash != NULL);
#line 213 "../src/Views/FirewallPanel.vala"
	_tmp0_ = g_strdup (_ ("Unknown"));
#line 213 "../src/Views/FirewallPanel.vala"
	action = _tmp0_;
#line 214 "../src/Views/FirewallPanel.vala"
	if (rule->action == SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_ALLOW) {
#line 1388 "FirewallPanel.c"
		gchar* _tmp1_;
#line 215 "../src/Views/FirewallPanel.vala"
		_tmp1_ = g_strdup (_ ("Allow"));
#line 215 "../src/Views/FirewallPanel.vala"
		_g_free0 (action);
#line 215 "../src/Views/FirewallPanel.vala"
		action = _tmp1_;
#line 1396 "FirewallPanel.c"
	} else {
#line 216 "../src/Views/FirewallPanel.vala"
		if (rule->action == SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_DENY) {
#line 1400 "FirewallPanel.c"
			gchar* _tmp2_;
#line 217 "../src/Views/FirewallPanel.vala"
			_tmp2_ = g_strdup (_ ("Deny"));
#line 217 "../src/Views/FirewallPanel.vala"
			_g_free0 (action);
#line 217 "../src/Views/FirewallPanel.vala"
			action = _tmp2_;
#line 1408 "FirewallPanel.c"
		} else {
#line 218 "../src/Views/FirewallPanel.vala"
			if (rule->action == SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_REJECT) {
#line 1412 "FirewallPanel.c"
				gchar* _tmp3_;
#line 219 "../src/Views/FirewallPanel.vala"
				_tmp3_ = g_strdup (_ ("Reject"));
#line 219 "../src/Views/FirewallPanel.vala"
				_g_free0 (action);
#line 219 "../src/Views/FirewallPanel.vala"
				action = _tmp3_;
#line 1420 "FirewallPanel.c"
			} else {
#line 220 "../src/Views/FirewallPanel.vala"
				if (rule->action == SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_LIMIT) {
#line 1424 "FirewallPanel.c"
					gchar* _tmp4_;
#line 221 "../src/Views/FirewallPanel.vala"
					_tmp4_ = g_strdup (_ ("Limit"));
#line 221 "../src/Views/FirewallPanel.vala"
					_g_free0 (action);
#line 221 "../src/Views/FirewallPanel.vala"
					action = _tmp4_;
#line 1432 "FirewallPanel.c"
				}
			}
		}
	}
#line 223 "../src/Views/FirewallPanel.vala"
	_tmp5_ = g_strdup (_ ("Unknown"));
#line 223 "../src/Views/FirewallPanel.vala"
	protocol = _tmp5_;
#line 224 "../src/Views/FirewallPanel.vala"
	if (rule->protocol == SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_UDP) {
#line 1443 "FirewallPanel.c"
		gchar* _tmp6_;
#line 225 "../src/Views/FirewallPanel.vala"
		_tmp6_ = g_strdup ("UDP");
#line 225 "../src/Views/FirewallPanel.vala"
		_g_free0 (protocol);
#line 225 "../src/Views/FirewallPanel.vala"
		protocol = _tmp6_;
#line 1451 "FirewallPanel.c"
	} else {
#line 226 "../src/Views/FirewallPanel.vala"
		if (rule->protocol == SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_TCP) {
#line 1455 "FirewallPanel.c"
			gchar* _tmp7_;
#line 227 "../src/Views/FirewallPanel.vala"
			_tmp7_ = g_strdup ("TCP");
#line 227 "../src/Views/FirewallPanel.vala"
			_g_free0 (protocol);
#line 227 "../src/Views/FirewallPanel.vala"
			protocol = _tmp7_;
#line 1463 "FirewallPanel.c"
		} else {
#line 228 "../src/Views/FirewallPanel.vala"
			if (rule->protocol == SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_BOTH) {
#line 1467 "FirewallPanel.c"
				gchar* _tmp8_;
#line 229 "../src/Views/FirewallPanel.vala"
				_tmp8_ = g_strdup ("TCP/UDP");
#line 229 "../src/Views/FirewallPanel.vala"
				_g_free0 (protocol);
#line 229 "../src/Views/FirewallPanel.vala"
				protocol = _tmp8_;
#line 1475 "FirewallPanel.c"
			}
		}
	}
#line 231 "../src/Views/FirewallPanel.vala"
	_tmp9_ = g_strdup (_ ("Unknown"));
#line 231 "../src/Views/FirewallPanel.vala"
	direction = _tmp9_;
#line 232 "../src/Views/FirewallPanel.vala"
	if (rule->direction == SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_IN) {
#line 1485 "FirewallPanel.c"
		gchar* _tmp10_;
#line 233 "../src/Views/FirewallPanel.vala"
		_tmp10_ = g_strdup (_ ("In"));
#line 233 "../src/Views/FirewallPanel.vala"
		_g_free0 (direction);
#line 233 "../src/Views/FirewallPanel.vala"
		direction = _tmp10_;
#line 1493 "FirewallPanel.c"
	} else {
#line 234 "../src/Views/FirewallPanel.vala"
		if (rule->direction == SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_OUT) {
#line 1497 "FirewallPanel.c"
			gchar* _tmp11_;
#line 235 "../src/Views/FirewallPanel.vala"
			_tmp11_ = g_strdup (_ ("Out"));
#line 235 "../src/Views/FirewallPanel.vala"
			_g_free0 (direction);
#line 235 "../src/Views/FirewallPanel.vala"
			direction = _tmp11_;
#line 1505 "FirewallPanel.c"
		}
	}
#line 237 "../src/Views/FirewallPanel.vala"
	_tmp12_ = g_strdup (_ ("Unknown"));
#line 237 "../src/Views/FirewallPanel.vala"
	version = _tmp12_;
#line 238 "../src/Views/FirewallPanel.vala"
	if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6) {
#line 1514 "FirewallPanel.c"
		gchar* _tmp13_;
#line 239 "../src/Views/FirewallPanel.vala"
		_tmp13_ = g_strdup ("IPv6");
#line 239 "../src/Views/FirewallPanel.vala"
		_g_free0 (version);
#line 239 "../src/Views/FirewallPanel.vala"
		version = _tmp13_;
#line 1522 "FirewallPanel.c"
	} else {
#line 240 "../src/Views/FirewallPanel.vala"
		if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4) {
#line 1526 "FirewallPanel.c"
			gchar* _tmp14_;
#line 241 "../src/Views/FirewallPanel.vala"
			_tmp14_ = g_strdup ("IPv4");
#line 241 "../src/Views/FirewallPanel.vala"
			_g_free0 (version);
#line 241 "../src/Views/FirewallPanel.vala"
			version = _tmp14_;
#line 1534 "FirewallPanel.c"
		}
	}
#line 244 "../src/Views/FirewallPanel.vala"
	_tmp15_ = g_strdup ("");
#line 244 "../src/Views/FirewallPanel.vala"
	from = _tmp15_;
#line 245 "../src/Views/FirewallPanel.vala"
	_tmp16_ = g_strdup ("");
#line 245 "../src/Views/FirewallPanel.vala"
	to = _tmp16_;
#line 246 "../src/Views/FirewallPanel.vala"
	_tmp17_ = rule->from_ports;
#line 246 "../src/Views/FirewallPanel.vala"
	if (g_strcmp0 (_tmp17_, "") != 0) {
#line 1549 "FirewallPanel.c"
		gboolean _tmp18_ = FALSE;
		const gchar* _tmp19_;
#line 247 "../src/Views/FirewallPanel.vala"
		_tmp19_ = rule->from_ports;
#line 247 "../src/Views/FirewallPanel.vala"
		if (string_contains (_tmp19_, ":")) {
#line 247 "../src/Views/FirewallPanel.vala"
			_tmp18_ = TRUE;
#line 1558 "FirewallPanel.c"
		} else {
			const gchar* _tmp20_;
#line 247 "../src/Views/FirewallPanel.vala"
			_tmp20_ = rule->from_ports;
#line 247 "../src/Views/FirewallPanel.vala"
			_tmp18_ = string_contains (_tmp20_, ",");
#line 1565 "FirewallPanel.c"
		}
#line 247 "../src/Views/FirewallPanel.vala"
		if (_tmp18_) {
#line 1569 "FirewallPanel.c"
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 248 "../src/Views/FirewallPanel.vala"
			_tmp21_ = rule->from;
#line 248 "../src/Views/FirewallPanel.vala"
			_tmp22_ = rule->from_ports;
#line 248 "../src/Views/FirewallPanel.vala"
			_tmp23_ = string_replace (_tmp22_, ":", "-");
#line 248 "../src/Views/FirewallPanel.vala"
			_tmp24_ = _tmp23_;
#line 248 "../src/Views/FirewallPanel.vala"
			_tmp25_ = g_strdup_printf (_ ("%s Ports %s"), _tmp21_, _tmp24_);
#line 248 "../src/Views/FirewallPanel.vala"
			_g_free0 (from);
#line 248 "../src/Views/FirewallPanel.vala"
			from = _tmp25_;
#line 248 "../src/Views/FirewallPanel.vala"
			_g_free0 (_tmp24_);
#line 1591 "FirewallPanel.c"
		} else {
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 250 "../src/Views/FirewallPanel.vala"
			_tmp26_ = rule->from;
#line 250 "../src/Views/FirewallPanel.vala"
			_tmp27_ = rule->from_ports;
#line 250 "../src/Views/FirewallPanel.vala"
			_tmp28_ = string_replace (_tmp27_, ":", "-");
#line 250 "../src/Views/FirewallPanel.vala"
			_tmp29_ = _tmp28_;
#line 250 "../src/Views/FirewallPanel.vala"
			_tmp30_ = g_strdup_printf (_ ("%s Port %s"), _tmp26_, _tmp29_);
#line 250 "../src/Views/FirewallPanel.vala"
			_g_free0 (from);
#line 250 "../src/Views/FirewallPanel.vala"
			from = _tmp30_;
#line 250 "../src/Views/FirewallPanel.vala"
			_g_free0 (_tmp29_);
#line 1614 "FirewallPanel.c"
		}
	} else {
		const gchar* _tmp31_;
		gchar* _tmp32_;
#line 253 "../src/Views/FirewallPanel.vala"
		_tmp31_ = rule->from;
#line 253 "../src/Views/FirewallPanel.vala"
		_tmp32_ = g_strdup (_tmp31_);
#line 253 "../src/Views/FirewallPanel.vala"
		_g_free0 (from);
#line 253 "../src/Views/FirewallPanel.vala"
		from = _tmp32_;
#line 1627 "FirewallPanel.c"
	}
#line 256 "../src/Views/FirewallPanel.vala"
	_tmp33_ = rule->to_ports;
#line 256 "../src/Views/FirewallPanel.vala"
	if (g_strcmp0 (_tmp33_, "") != 0) {
#line 1633 "FirewallPanel.c"
		gboolean _tmp34_ = FALSE;
		const gchar* _tmp35_;
#line 257 "../src/Views/FirewallPanel.vala"
		_tmp35_ = rule->to_ports;
#line 257 "../src/Views/FirewallPanel.vala"
		if (string_contains (_tmp35_, ":")) {
#line 257 "../src/Views/FirewallPanel.vala"
			_tmp34_ = TRUE;
#line 1642 "FirewallPanel.c"
		} else {
			const gchar* _tmp36_;
#line 257 "../src/Views/FirewallPanel.vala"
			_tmp36_ = rule->to_ports;
#line 257 "../src/Views/FirewallPanel.vala"
			_tmp34_ = string_contains (_tmp36_, ",");
#line 1649 "FirewallPanel.c"
		}
#line 257 "../src/Views/FirewallPanel.vala"
		if (_tmp34_) {
#line 1653 "FirewallPanel.c"
			const gchar* _tmp37_;
			const gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
#line 258 "../src/Views/FirewallPanel.vala"
			_tmp37_ = rule->to;
#line 258 "../src/Views/FirewallPanel.vala"
			_tmp38_ = rule->to_ports;
#line 258 "../src/Views/FirewallPanel.vala"
			_tmp39_ = string_replace (_tmp38_, ":", "-");
#line 258 "../src/Views/FirewallPanel.vala"
			_tmp40_ = _tmp39_;
#line 258 "../src/Views/FirewallPanel.vala"
			_tmp41_ = g_strdup_printf (_ ("%s Ports %s"), _tmp37_, _tmp40_);
#line 258 "../src/Views/FirewallPanel.vala"
			_g_free0 (to);
#line 258 "../src/Views/FirewallPanel.vala"
			to = _tmp41_;
#line 258 "../src/Views/FirewallPanel.vala"
			_g_free0 (_tmp40_);
#line 1675 "FirewallPanel.c"
		} else {
			const gchar* _tmp42_;
			const gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
#line 260 "../src/Views/FirewallPanel.vala"
			_tmp42_ = rule->to;
#line 260 "../src/Views/FirewallPanel.vala"
			_tmp43_ = rule->to_ports;
#line 260 "../src/Views/FirewallPanel.vala"
			_tmp44_ = string_replace (_tmp43_, ":", "-");
#line 260 "../src/Views/FirewallPanel.vala"
			_tmp45_ = _tmp44_;
#line 260 "../src/Views/FirewallPanel.vala"
			_tmp46_ = g_strdup_printf (_ ("%s Port %s"), _tmp42_, _tmp45_);
#line 260 "../src/Views/FirewallPanel.vala"
			_g_free0 (to);
#line 260 "../src/Views/FirewallPanel.vala"
			to = _tmp46_;
#line 260 "../src/Views/FirewallPanel.vala"
			_g_free0 (_tmp45_);
#line 1698 "FirewallPanel.c"
		}
	} else {
		const gchar* _tmp47_;
		gchar* _tmp48_;
#line 263 "../src/Views/FirewallPanel.vala"
		_tmp47_ = rule->to;
#line 263 "../src/Views/FirewallPanel.vala"
		_tmp48_ = g_strdup (_tmp47_);
#line 263 "../src/Views/FirewallPanel.vala"
		_g_free0 (to);
#line 263 "../src/Views/FirewallPanel.vala"
		to = _tmp48_;
#line 1711 "FirewallPanel.c"
	}
#line 266 "../src/Views/FirewallPanel.vala"
	_tmp49_ = self->priv->list_store;
#line 266 "../src/Views/FirewallPanel.vala"
	gtk_list_store_append (_tmp49_, &_tmp50_);
#line 266 "../src/Views/FirewallPanel.vala"
	iter = _tmp50_;
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp51_ = self->priv->list_store;
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp52_ = iter;
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp53_ = action;
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp54_ = protocol;
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp55_ = direction;
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp56_ = version;
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp57_ = to;
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp58_ = string_strip (_tmp57_);
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp59_ = _tmp58_;
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp60_ = from;
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp61_ = string_strip (_tmp60_);
#line 267 "../src/Views/FirewallPanel.vala"
	_tmp62_ = _tmp61_;
#line 267 "../src/Views/FirewallPanel.vala"
	gtk_list_store_set (_tmp51_, &_tmp52_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION, _tmp53_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL, _tmp54_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION, _tmp55_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6, _tmp56_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, enabled, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, rule, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO, _tmp59_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM, _tmp62_, -1);
#line 267 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp62_);
#line 267 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp59_);
#line 211 "../src/Views/FirewallPanel.vala"
	_g_free0 (to);
#line 211 "../src/Views/FirewallPanel.vala"
	_g_free0 (from);
#line 211 "../src/Views/FirewallPanel.vala"
	_g_free0 (version);
#line 211 "../src/Views/FirewallPanel.vala"
	_g_free0 (direction);
#line 211 "../src/Views/FirewallPanel.vala"
	_g_free0 (protocol);
#line 211 "../src/Views/FirewallPanel.vala"
	_g_free0 (action);
#line 1761 "FirewallPanel.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 272 "../src/Views/FirewallPanel.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 272 "../src/Views/FirewallPanel.vala"
	return _data4_;
#line 1771 "FirewallPanel.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 272 "../src/Views/FirewallPanel.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1781 "FirewallPanel.c"
		SecurityPrivacyFirewallPanel* self;
#line 272 "../src/Views/FirewallPanel.vala"
		self = _data4_->self;
#line 272 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data4_->add_button);
#line 272 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (self);
#line 272 "../src/Views/FirewallPanel.vala"
		g_slice_free (Block4Data, _data4_);
#line 1791 "FirewallPanel.c"
	}
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 300 "../src/Views/FirewallPanel.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 1800 "FirewallPanel.c"
}

static void
__lambda10_ (SecurityPrivacyFirewallPanel* self,
             const gchar* path)
{
	GValue active = {0};
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_;
	GValue _tmp6_ = {0};
	gboolean is_active = FALSE;
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	GValue rule_value = {0};
	GtkListStore* _tmp9_;
	GtkTreeIter _tmp10_;
	GValue _tmp11_ = {0};
	SecurityPrivacyUFWHelpersRule* rule = NULL;
	GObject* _tmp12_;
	SecurityPrivacyUFWHelpersRule* _tmp13_;
	gchar* gen_hash = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp14_;
	gchar* _tmp15_;
#line 297 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (path != NULL);
#line 300 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->list_store;
#line 300 "../src/Views/FirewallPanel.vala"
	_tmp1_ = gtk_tree_path_new_from_string (path);
#line 300 "../src/Views/FirewallPanel.vala"
	_tmp2_ = _tmp1_;
#line 300 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp0_, &_tmp3_, _tmp2_);
#line 300 "../src/Views/FirewallPanel.vala"
	iter = _tmp3_;
#line 300 "../src/Views/FirewallPanel.vala"
	__vala_GtkTreePath_free0 (_tmp2_);
#line 301 "../src/Views/FirewallPanel.vala"
	_tmp4_ = self->priv->list_store;
#line 301 "../src/Views/FirewallPanel.vala"
	_tmp5_ = iter;
#line 301 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp4_, &_tmp5_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, &_tmp6_);
#line 301 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
#line 301 "../src/Views/FirewallPanel.vala"
	active = _tmp6_;
#line 302 "../src/Views/FirewallPanel.vala"
	is_active = !g_value_get_boolean (&active);
#line 303 "../src/Views/FirewallPanel.vala"
	_tmp7_ = self->priv->list_store;
#line 303 "../src/Views/FirewallPanel.vala"
	_tmp8_ = iter;
#line 303 "../src/Views/FirewallPanel.vala"
	gtk_list_store_set (_tmp7_, &_tmp8_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, is_active, -1);
#line 306 "../src/Views/FirewallPanel.vala"
	_tmp9_ = self->priv->list_store;
#line 306 "../src/Views/FirewallPanel.vala"
	_tmp10_ = iter;
#line 306 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp9_, &_tmp10_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp11_);
#line 306 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&rule_value) ? (g_value_unset (&rule_value), NULL) : NULL;
#line 306 "../src/Views/FirewallPanel.vala"
	rule_value = _tmp11_;
#line 307 "../src/Views/FirewallPanel.vala"
	_tmp12_ = g_value_get_object (&rule_value);
#line 307 "../src/Views/FirewallPanel.vala"
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, SecurityPrivacyUFWHelpersRule));
#line 307 "../src/Views/FirewallPanel.vala"
	rule = _tmp13_;
#line 308 "../src/Views/FirewallPanel.vala"
	_tmp14_ = rule;
#line 308 "../src/Views/FirewallPanel.vala"
	_tmp15_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp14_);
#line 308 "../src/Views/FirewallPanel.vala"
	gen_hash = _tmp15_;
#line 309 "../src/Views/FirewallPanel.vala"
	if (is_active == FALSE) {
#line 1885 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp16_;
#line 310 "../src/Views/FirewallPanel.vala"
		_tmp16_ = rule;
#line 310 "../src/Views/FirewallPanel.vala"
		security_privacy_firewall_panel_disable_rule (self, _tmp16_);
#line 1891 "FirewallPanel.c"
	} else {
		const gchar* _tmp17_;
#line 312 "../src/Views/FirewallPanel.vala"
		_tmp17_ = gen_hash;
#line 312 "../src/Views/FirewallPanel.vala"
		security_privacy_firewall_panel_enable_rule (self, _tmp17_);
#line 1898 "FirewallPanel.c"
	}
#line 315 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_reload_rule_numbers (self);
#line 297 "../src/Views/FirewallPanel.vala"
	_g_free0 (gen_hash);
#line 297 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (rule);
#line 297 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&rule_value) ? (g_value_unset (&rule_value), NULL) : NULL;
#line 297 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
#line 1910 "FirewallPanel.c"
}

static void
___lambda10__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                               const gchar* path,
                                               gpointer self)
{
#line 297 "../src/Views/FirewallPanel.vala"
	__lambda10_ ((SecurityPrivacyFirewallPanel*) self, path);
#line 1920 "FirewallPanel.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 323 "../src/Views/FirewallPanel.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 323 "../src/Views/FirewallPanel.vala"
	return _data5_;
#line 1930 "FirewallPanel.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 323 "../src/Views/FirewallPanel.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1940 "FirewallPanel.c"
		SecurityPrivacyFirewallPanel* self;
#line 323 "../src/Views/FirewallPanel.vala"
		self = _data5_->_data4_->self;
#line 323 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data5_->ports_entry);
#line 323 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data5_->direction_combobox);
#line 323 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data5_->version_combobox);
#line 323 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data5_->protocol_combobox);
#line 323 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data5_->policy_combobox);
#line 323 "../src/Views/FirewallPanel.vala"
		block4_data_unref (_data5_->_data4_);
#line 323 "../src/Views/FirewallPanel.vala"
		_data5_->_data4_ = NULL;
#line 323 "../src/Views/FirewallPanel.vala"
		g_slice_free (Block5Data, _data5_);
#line 1960 "FirewallPanel.c"
	}
}

static void
__lambda12_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	SecurityPrivacyFirewallPanel* self;
	SecurityPrivacyUFWHelpersRule* rule = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp19_;
	gint _tmp20_;
	SecurityPrivacyUFWHelpersRule* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	SecurityPrivacyUFWHelpersRule* _tmp30_;
	GtkPopover* _tmp31_;
#line 373 "../src/Views/FirewallPanel.vala"
	_data4_ = _data5_->_data4_;
#line 373 "../src/Views/FirewallPanel.vala"
	self = _data4_->self;
#line 374 "../src/Views/FirewallPanel.vala"
	_tmp0_ = security_privacy_ufw_helpers_rule_new ();
#line 374 "../src/Views/FirewallPanel.vala"
	rule = _tmp0_;
#line 375 "../src/Views/FirewallPanel.vala"
	_tmp1_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->direction_combobox);
#line 375 "../src/Views/FirewallPanel.vala"
	_tmp2_ = _tmp1_;
#line 375 "../src/Views/FirewallPanel.vala"
	if (_tmp2_ == 0) {
#line 1999 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp3_;
#line 376 "../src/Views/FirewallPanel.vala"
		_tmp3_ = rule;
#line 376 "../src/Views/FirewallPanel.vala"
		_tmp3_->direction = SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_IN;
#line 2005 "FirewallPanel.c"
	} else {
		SecurityPrivacyUFWHelpersRule* _tmp4_;
#line 378 "../src/Views/FirewallPanel.vala"
		_tmp4_ = rule;
#line 378 "../src/Views/FirewallPanel.vala"
		_tmp4_->direction = SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_OUT;
#line 2012 "FirewallPanel.c"
	}
#line 380 "../src/Views/FirewallPanel.vala"
	_tmp5_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->protocol_combobox);
#line 380 "../src/Views/FirewallPanel.vala"
	_tmp6_ = _tmp5_;
#line 380 "../src/Views/FirewallPanel.vala"
	if (_tmp6_ == 0) {
#line 2020 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp7_;
#line 381 "../src/Views/FirewallPanel.vala"
		_tmp7_ = rule;
#line 381 "../src/Views/FirewallPanel.vala"
		_tmp7_->protocol = SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_TCP;
#line 2026 "FirewallPanel.c"
	} else {
		SecurityPrivacyUFWHelpersRule* _tmp8_;
#line 383 "../src/Views/FirewallPanel.vala"
		_tmp8_ = rule;
#line 383 "../src/Views/FirewallPanel.vala"
		_tmp8_->protocol = SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_UDP;
#line 2033 "FirewallPanel.c"
	}
#line 385 "../src/Views/FirewallPanel.vala"
	_tmp9_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->policy_combobox);
#line 385 "../src/Views/FirewallPanel.vala"
	_tmp10_ = _tmp9_;
#line 385 "../src/Views/FirewallPanel.vala"
	if (_tmp10_ == 0) {
#line 2041 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp11_;
#line 386 "../src/Views/FirewallPanel.vala"
		_tmp11_ = rule;
#line 386 "../src/Views/FirewallPanel.vala"
		_tmp11_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_ALLOW;
#line 2047 "FirewallPanel.c"
	} else {
		gint _tmp12_;
		gint _tmp13_;
#line 387 "../src/Views/FirewallPanel.vala"
		_tmp12_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->policy_combobox);
#line 387 "../src/Views/FirewallPanel.vala"
		_tmp13_ = _tmp12_;
#line 387 "../src/Views/FirewallPanel.vala"
		if (_tmp13_ == 1) {
#line 2057 "FirewallPanel.c"
			SecurityPrivacyUFWHelpersRule* _tmp14_;
#line 388 "../src/Views/FirewallPanel.vala"
			_tmp14_ = rule;
#line 388 "../src/Views/FirewallPanel.vala"
			_tmp14_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_DENY;
#line 2063 "FirewallPanel.c"
		} else {
			gint _tmp15_;
			gint _tmp16_;
#line 389 "../src/Views/FirewallPanel.vala"
			_tmp15_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->policy_combobox);
#line 389 "../src/Views/FirewallPanel.vala"
			_tmp16_ = _tmp15_;
#line 389 "../src/Views/FirewallPanel.vala"
			if (_tmp16_ == 2) {
#line 2073 "FirewallPanel.c"
				SecurityPrivacyUFWHelpersRule* _tmp17_;
#line 390 "../src/Views/FirewallPanel.vala"
				_tmp17_ = rule;
#line 390 "../src/Views/FirewallPanel.vala"
				_tmp17_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_REJECT;
#line 2079 "FirewallPanel.c"
			} else {
				SecurityPrivacyUFWHelpersRule* _tmp18_;
#line 392 "../src/Views/FirewallPanel.vala"
				_tmp18_ = rule;
#line 392 "../src/Views/FirewallPanel.vala"
				_tmp18_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_LIMIT;
#line 2086 "FirewallPanel.c"
			}
		}
	}
#line 394 "../src/Views/FirewallPanel.vala"
	_tmp19_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->version_combobox);
#line 394 "../src/Views/FirewallPanel.vala"
	_tmp20_ = _tmp19_;
#line 394 "../src/Views/FirewallPanel.vala"
	if (_tmp20_ == 0) {
#line 2096 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp21_;
#line 395 "../src/Views/FirewallPanel.vala"
		_tmp21_ = rule;
#line 395 "../src/Views/FirewallPanel.vala"
		_tmp21_->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4;
#line 2102 "FirewallPanel.c"
	} else {
		gint _tmp22_;
		gint _tmp23_;
#line 396 "../src/Views/FirewallPanel.vala"
		_tmp22_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->version_combobox);
#line 396 "../src/Views/FirewallPanel.vala"
		_tmp23_ = _tmp22_;
#line 396 "../src/Views/FirewallPanel.vala"
		if (_tmp23_ == 1) {
#line 2112 "FirewallPanel.c"
			SecurityPrivacyUFWHelpersRule* _tmp24_;
#line 397 "../src/Views/FirewallPanel.vala"
			_tmp24_ = rule;
#line 397 "../src/Views/FirewallPanel.vala"
			_tmp24_->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6;
#line 2118 "FirewallPanel.c"
		} else {
			SecurityPrivacyUFWHelpersRule* _tmp25_;
#line 399 "../src/Views/FirewallPanel.vala"
			_tmp25_ = rule;
#line 399 "../src/Views/FirewallPanel.vala"
			_tmp25_->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_BOTH;
#line 2125 "FirewallPanel.c"
		}
	}
#line 401 "../src/Views/FirewallPanel.vala"
	_tmp26_ = rule;
#line 401 "../src/Views/FirewallPanel.vala"
	_tmp27_ = gtk_entry_get_text (_data5_->ports_entry);
#line 401 "../src/Views/FirewallPanel.vala"
	_tmp28_ = _tmp27_;
#line 401 "../src/Views/FirewallPanel.vala"
	_tmp29_ = string_replace (_tmp28_, "-", ":");
#line 401 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp26_->to_ports);
#line 401 "../src/Views/FirewallPanel.vala"
	_tmp26_->to_ports = _tmp29_;
#line 402 "../src/Views/FirewallPanel.vala"
	_tmp30_ = rule;
#line 402 "../src/Views/FirewallPanel.vala"
	security_privacy_ufw_helpers_add_rule (_tmp30_);
#line 403 "../src/Views/FirewallPanel.vala"
	_tmp31_ = self->priv->add_popover;
#line 403 "../src/Views/FirewallPanel.vala"
	gtk_widget_hide ((GtkWidget*) _tmp31_);
#line 404 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_show_rules (self);
#line 373 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (rule);
#line 2152 "FirewallPanel.c"
}

static void
___lambda12__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 373 "../src/Views/FirewallPanel.vala"
	__lambda12_ (self);
#line 2161 "FirewallPanel.c"
}

static void
__lambda11_ (Block4Data* _data4_)
{
	SecurityPrivacyFirewallPanel* self;
	Block5Data* _data5_;
	GtkGrid* popover_grid = NULL;
	GtkGrid* _tmp0_;
	GtkPopover* _tmp1_;
	GtkPopover* _tmp2_;
	GtkLabel* policy_label = NULL;
	GtkLabel* _tmp3_;
	GtkComboBoxText* _tmp4_;
	GtkLabel* protocol_label = NULL;
	GtkLabel* _tmp5_;
	GtkComboBoxText* _tmp6_;
	GtkLabel* version_label = NULL;
	GtkLabel* _tmp7_;
	GtkComboBoxText* _tmp8_;
	GtkLabel* direction_label = NULL;
	GtkLabel* _tmp9_;
	GtkComboBoxText* _tmp10_;
	GtkLabel* ports_label = NULL;
	GtkLabel* _tmp11_;
	GtkEntry* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkButton* do_add_button = NULL;
	GtkButton* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkGrid* add_button_grid = NULL;
	GtkGrid* _tmp17_;
	GtkPopover* _tmp18_;
#line 323 "../src/Views/FirewallPanel.vala"
	self = _data4_->self;
#line 323 "../src/Views/FirewallPanel.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 323 "../src/Views/FirewallPanel.vala"
	_data5_->_ref_count_ = 1;
#line 323 "../src/Views/FirewallPanel.vala"
	_data5_->_data4_ = block4_data_ref (_data4_);
#line 324 "../src/Views/FirewallPanel.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 324 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp0_);
#line 324 "../src/Views/FirewallPanel.vala"
	popover_grid = _tmp0_;
#line 325 "../src/Views/FirewallPanel.vala"
	g_object_set ((GtkWidget*) popover_grid, "margin", 6, NULL);
#line 326 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_margin_top ((GtkWidget*) popover_grid, 12);
#line 327 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_margin_start ((GtkWidget*) popover_grid, 12);
#line 328 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) popover_grid, 9);
#line 329 "../src/Views/FirewallPanel.vala"
	gtk_grid_set_column_spacing (popover_grid, 12);
#line 330 "../src/Views/FirewallPanel.vala"
	gtk_grid_set_row_spacing (popover_grid, 6);
#line 331 "../src/Views/FirewallPanel.vala"
	_tmp1_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) _data4_->add_button);
#line 331 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp1_);
#line 331 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->add_popover);
#line 331 "../src/Views/FirewallPanel.vala"
	self->priv->add_popover = _tmp1_;
#line 332 "../src/Views/FirewallPanel.vala"
	_tmp2_ = self->priv->add_popover;
#line 332 "../src/Views/FirewallPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp2_, (GtkWidget*) popover_grid);
#line 334 "../src/Views/FirewallPanel.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (_ ("Action:"));
#line 334 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp3_);
#line 334 "../src/Views/FirewallPanel.vala"
	policy_label = _tmp3_;
#line 335 "../src/Views/FirewallPanel.vala"
	gtk_label_set_xalign (policy_label, (gfloat) 1);
#line 336 "../src/Views/FirewallPanel.vala"
	_tmp4_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 336 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp4_);
#line 336 "../src/Views/FirewallPanel.vala"
	_data5_->policy_combobox = _tmp4_;
#line 337 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->policy_combobox, _ ("Allow"));
#line 338 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->policy_combobox, _ ("Deny"));
#line 339 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->policy_combobox, _ ("Reject"));
#line 340 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->policy_combobox, _ ("Limit"));
#line 341 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _data5_->policy_combobox, 0);
#line 343 "../src/Views/FirewallPanel.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Protocol:"));
#line 343 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp5_);
#line 343 "../src/Views/FirewallPanel.vala"
	protocol_label = _tmp5_;
#line 344 "../src/Views/FirewallPanel.vala"
	gtk_label_set_xalign (protocol_label, (gfloat) 1);
#line 345 "../src/Views/FirewallPanel.vala"
	_tmp6_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 345 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp6_);
#line 345 "../src/Views/FirewallPanel.vala"
	_data5_->protocol_combobox = _tmp6_;
#line 346 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->protocol_combobox, "TCP");
#line 347 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->protocol_combobox, "UDP");
#line 348 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _data5_->protocol_combobox, 0);
#line 350 "../src/Views/FirewallPanel.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new (_ ("Version:"));
#line 350 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp7_);
#line 350 "../src/Views/FirewallPanel.vala"
	version_label = _tmp7_;
#line 351 "../src/Views/FirewallPanel.vala"
	gtk_label_set_xalign (version_label, (gfloat) 1);
#line 352 "../src/Views/FirewallPanel.vala"
	_tmp8_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 352 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp8_);
#line 352 "../src/Views/FirewallPanel.vala"
	_data5_->version_combobox = _tmp8_;
#line 353 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->version_combobox, "IPv4");
#line 354 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->version_combobox, "IPv6");
#line 355 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->version_combobox, _ ("Both"));
#line 356 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _data5_->version_combobox, 0);
#line 358 "../src/Views/FirewallPanel.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (_ ("Direction:"));
#line 358 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp9_);
#line 358 "../src/Views/FirewallPanel.vala"
	direction_label = _tmp9_;
#line 359 "../src/Views/FirewallPanel.vala"
	gtk_label_set_xalign (direction_label, (gfloat) 1);
#line 360 "../src/Views/FirewallPanel.vala"
	_tmp10_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 360 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp10_);
#line 360 "../src/Views/FirewallPanel.vala"
	_data5_->direction_combobox = _tmp10_;
#line 361 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->direction_combobox, _ ("In"));
#line 362 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data5_->direction_combobox, _ ("Out"));
#line 363 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _data5_->direction_combobox, 0);
#line 365 "../src/Views/FirewallPanel.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new (_ ("Ports:"));
#line 365 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp11_);
#line 365 "../src/Views/FirewallPanel.vala"
	ports_label = _tmp11_;
#line 366 "../src/Views/FirewallPanel.vala"
	gtk_label_set_xalign (ports_label, (gfloat) 1);
#line 367 "../src/Views/FirewallPanel.vala"
	_tmp12_ = (GtkEntry*) gtk_entry_new ();
#line 367 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp12_);
#line 367 "../src/Views/FirewallPanel.vala"
	_data5_->ports_entry = _tmp12_;
#line 368 "../src/Views/FirewallPanel.vala"
	gtk_entry_set_input_purpose (_data5_->ports_entry, GTK_INPUT_PURPOSE_NUMBER);
#line 369 "../src/Views/FirewallPanel.vala"
	_tmp13_ = g_strdup_printf (_ ("%d or %d-%d"), 80, 80, 85);
#line 369 "../src/Views/FirewallPanel.vala"
	_tmp14_ = _tmp13_;
#line 369 "../src/Views/FirewallPanel.vala"
	gtk_entry_set_placeholder_text (_data5_->ports_entry, _tmp14_);
#line 369 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp14_);
#line 371 "../src/Views/FirewallPanel.vala"
	_tmp15_ = (GtkButton*) gtk_button_new_with_label (_ ("Add Rule"));
#line 371 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp15_);
#line 371 "../src/Views/FirewallPanel.vala"
	do_add_button = _tmp15_;
#line 372 "../src/Views/FirewallPanel.vala"
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) do_add_button);
#line 372 "../src/Views/FirewallPanel.vala"
	gtk_style_context_add_class (_tmp16_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 373 "../src/Views/FirewallPanel.vala"
	g_signal_connect_data (do_add_button, "clicked", (GCallback) ___lambda12__gtk_button_clicked, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 407 "../src/Views/FirewallPanel.vala"
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
#line 407 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp17_);
#line 407 "../src/Views/FirewallPanel.vala"
	add_button_grid = _tmp17_;
#line 408 "../src/Views/FirewallPanel.vala"
	gtk_container_add ((GtkContainer*) add_button_grid, (GtkWidget*) do_add_button);
#line 409 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) add_button_grid, GTK_ALIGN_END);
#line 411 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) policy_label, 0, 0, 1, 1);
#line 412 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) _data5_->policy_combobox, 1, 0, 1, 1);
#line 413 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) protocol_label, 0, 1, 1, 1);
#line 414 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) _data5_->protocol_combobox, 1, 1, 1, 1);
#line 415 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) version_label, 0, 2, 1, 1);
#line 416 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) _data5_->version_combobox, 1, 2, 1, 1);
#line 417 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) direction_label, 0, 3, 1, 1);
#line 418 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) _data5_->direction_combobox, 1, 3, 1, 1);
#line 419 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) ports_label, 0, 4, 1, 1);
#line 420 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) _data5_->ports_entry, 1, 4, 1, 1);
#line 421 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) add_button_grid, 0, 5, 2, 1);
#line 423 "../src/Views/FirewallPanel.vala"
	_tmp18_ = self->priv->add_popover;
#line 423 "../src/Views/FirewallPanel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp18_);
#line 323 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (add_button_grid);
#line 323 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (do_add_button);
#line 323 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (ports_label);
#line 323 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (direction_label);
#line 323 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (version_label);
#line 323 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (protocol_label);
#line 323 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (policy_label);
#line 323 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (popover_grid);
#line 323 "../src/Views/FirewallPanel.vala"
	block5_data_unref (_data5_);
#line 323 "../src/Views/FirewallPanel.vala"
	_data5_ = NULL;
#line 2412 "FirewallPanel.c"
}

static void
___lambda11__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 323 "../src/Views/FirewallPanel.vala"
	__lambda11_ (self);
#line 2421 "FirewallPanel.c"
}

static void
__lambda13_ (SecurityPrivacyFirewallPanel* self)
{
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	GtkTreeView* _tmp0_;
	GtkTreePath* _tmp1_ = NULL;
	GtkTreeViewColumn* _tmp2_ = NULL;
	GtkTreeViewColumn* _tmp3_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	GValue val = {0};
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	GValue _tmp9_ = {0};
	SecurityPrivacyUFWHelpersRule* rule = NULL;
	GObject* _tmp10_;
	SecurityPrivacyUFWHelpersRule* _tmp11_;
	gchar* gen_hash = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp12_;
	gchar* _tmp13_;
	GValue active = {0};
	GtkListStore* _tmp14_;
	GtkTreeIter _tmp15_;
	GValue _tmp16_ = {0};
#line 432 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->view;
#line 432 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_get_cursor (_tmp0_, &_tmp1_, &_tmp2_);
#line 432 "../src/Views/FirewallPanel.vala"
	__vala_GtkTreePath_free0 (path);
#line 432 "../src/Views/FirewallPanel.vala"
	path = _tmp1_;
#line 432 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (column);
#line 432 "../src/Views/FirewallPanel.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 432 "../src/Views/FirewallPanel.vala"
	column = _tmp3_;
#line 434 "../src/Views/FirewallPanel.vala"
	_tmp4_ = self->priv->list_store;
#line 434 "../src/Views/FirewallPanel.vala"
	_tmp5_ = path;
#line 434 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp4_, &_tmp6_, _tmp5_);
#line 434 "../src/Views/FirewallPanel.vala"
	iter = _tmp6_;
#line 436 "../src/Views/FirewallPanel.vala"
	_tmp7_ = self->priv->list_store;
#line 436 "../src/Views/FirewallPanel.vala"
	_tmp8_ = iter;
#line 436 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp7_, &_tmp8_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp9_);
#line 436 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 436 "../src/Views/FirewallPanel.vala"
	val = _tmp9_;
#line 437 "../src/Views/FirewallPanel.vala"
	_tmp10_ = g_value_get_object (&val);
#line 437 "../src/Views/FirewallPanel.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, SecurityPrivacyUFWHelpersRule));
#line 437 "../src/Views/FirewallPanel.vala"
	rule = _tmp11_;
#line 438 "../src/Views/FirewallPanel.vala"
	_tmp12_ = rule;
#line 438 "../src/Views/FirewallPanel.vala"
	_tmp13_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp12_);
#line 438 "../src/Views/FirewallPanel.vala"
	gen_hash = _tmp13_;
#line 440 "../src/Views/FirewallPanel.vala"
	_tmp14_ = self->priv->list_store;
#line 440 "../src/Views/FirewallPanel.vala"
	_tmp15_ = iter;
#line 440 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp14_, &_tmp15_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, &_tmp16_);
#line 440 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
#line 440 "../src/Views/FirewallPanel.vala"
	active = _tmp16_;
#line 441 "../src/Views/FirewallPanel.vala"
	if (g_value_get_boolean (&active)) {
#line 2507 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp17_;
#line 442 "../src/Views/FirewallPanel.vala"
		_tmp17_ = rule;
#line 442 "../src/Views/FirewallPanel.vala"
		security_privacy_ufw_helpers_remove_rule (_tmp17_);
#line 2513 "FirewallPanel.c"
	} else {
		const gchar* _tmp18_;
#line 444 "../src/Views/FirewallPanel.vala"
		_tmp18_ = gen_hash;
#line 444 "../src/Views/FirewallPanel.vala"
		security_privacy_firewall_panel_delete_disabled_rule (self, _tmp18_);
#line 2520 "FirewallPanel.c"
	}
#line 446 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_show_rules (self);
#line 429 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
#line 429 "../src/Views/FirewallPanel.vala"
	_g_free0 (gen_hash);
#line 429 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (rule);
#line 429 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 429 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (column);
#line 429 "../src/Views/FirewallPanel.vala"
	__vala_GtkTreePath_free0 (path);
#line 2536 "FirewallPanel.c"
}

static void
___lambda13__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 429 "../src/Views/FirewallPanel.vala"
	__lambda13_ ((SecurityPrivacyFirewallPanel*) self);
#line 2545 "FirewallPanel.c"
}

static void
__lambda14_ (SecurityPrivacyFirewallPanel* self)
{
	GtkButton* _tmp0_;
#line 451 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->remove_button;
#line 451 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 2556 "FirewallPanel.c"
}

static void
___lambda14__gtk_tree_view_cursor_changed (GtkTreeView* _sender,
                                           gpointer self)
{
#line 450 "../src/Views/FirewallPanel.vala"
	__lambda14_ ((SecurityPrivacyFirewallPanel*) self);
#line 2565 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_create_treeview (SecurityPrivacyFirewallPanel* self)
{
	Block4Data* _data4_;
	GtkListStore* _tmp0_;
	GtkListStore* _tmp1_;
	GtkTreeView* _tmp2_;
	GtkTreeView* _tmp3_;
	GtkTreeView* _tmp4_;
	GtkCellRendererToggle* celltoggle = NULL;
	GtkCellRendererToggle* _tmp5_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp6_;
	GtkTreeView* _tmp7_;
	GtkTreeView* _tmp8_;
	GtkTreeView* _tmp9_;
	GtkTreeView* _tmp10_;
	GtkTreeView* _tmp11_;
	GtkTreeView* _tmp12_;
	GtkTreeView* _tmp13_;
	GtkActionBar* _tmp14_;
	GtkActionBar* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkButton* _tmp17_;
	GtkActionBar* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GtkButton* _tmp21_;
	GtkActionBar* _tmp22_;
	GtkButton* _tmp23_;
	GtkTreeView* _tmp24_;
	GtkGrid* view_grid = NULL;
	GtkGrid* _tmp25_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp26_;
	GtkTreeView* _tmp27_;
	GtkActionBar* _tmp28_;
	GtkFrame* frame = NULL;
	GtkFrame* _tmp29_;
	GtkGrid* _tmp30_;
	GtkGrid* _tmp31_;
#line 272 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/Views/FirewallPanel.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 272 "../src/Views/FirewallPanel.vala"
	_data4_->_ref_count_ = 1;
#line 272 "../src/Views/FirewallPanel.vala"
	_data4_->self = g_object_ref (self);
#line 273 "../src/Views/FirewallPanel.vala"
	_tmp0_ = gtk_list_store_new ((gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_BOOLEAN, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, -1);
#line 273 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->list_store);
#line 273 "../src/Views/FirewallPanel.vala"
	self->priv->list_store = _tmp0_;
#line 283 "../src/Views/FirewallPanel.vala"
	_tmp1_ = self->priv->list_store;
#line 283 "../src/Views/FirewallPanel.vala"
	_tmp2_ = (GtkTreeView*) gtk_tree_view_new_with_model ((GtkTreeModel*) _tmp1_);
#line 283 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp2_);
#line 283 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->view);
#line 283 "../src/Views/FirewallPanel.vala"
	self->priv->view = _tmp2_;
#line 284 "../src/Views/FirewallPanel.vala"
	_tmp3_ = self->priv->view;
#line 284 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp3_, TRUE);
#line 285 "../src/Views/FirewallPanel.vala"
	_tmp4_ = self->priv->view;
#line 285 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_set_activate_on_single_click (_tmp4_, TRUE);
#line 287 "../src/Views/FirewallPanel.vala"
	_tmp5_ = (GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ();
#line 287 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp5_);
#line 287 "../src/Views/FirewallPanel.vala"
	celltoggle = _tmp5_;
#line 288 "../src/Views/FirewallPanel.vala"
	_tmp6_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 288 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp6_);
#line 288 "../src/Views/FirewallPanel.vala"
	cell = _tmp6_;
#line 289 "../src/Views/FirewallPanel.vala"
	_tmp7_ = self->priv->view;
#line 289 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp7_, -1, _ ("Enabled"), (GtkCellRenderer*) celltoggle, "active", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, NULL);
#line 290 "../src/Views/FirewallPanel.vala"
	_tmp8_ = self->priv->view;
#line 290 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp8_, -1, _ ("Version"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6, NULL);
#line 291 "../src/Views/FirewallPanel.vala"
	_tmp9_ = self->priv->view;
#line 291 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp9_, -1, _ ("Action"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION, NULL);
#line 292 "../src/Views/FirewallPanel.vala"
	_tmp10_ = self->priv->view;
#line 292 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp10_, -1, _ ("Protocol"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL, NULL);
#line 293 "../src/Views/FirewallPanel.vala"
	_tmp11_ = self->priv->view;
#line 293 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp11_, -1, _ ("Direction"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION, NULL);
#line 294 "../src/Views/FirewallPanel.vala"
	_tmp12_ = self->priv->view;
#line 294 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp12_, -1, _ ("To"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO, NULL);
#line 295 "../src/Views/FirewallPanel.vala"
	_tmp13_ = self->priv->view;
#line 295 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp13_, -1, _ ("From"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM, NULL);
#line 297 "../src/Views/FirewallPanel.vala"
	g_signal_connect_object (celltoggle, "toggled", (GCallback) ___lambda10__gtk_cell_renderer_toggle_toggled, self, 0);
#line 318 "../src/Views/FirewallPanel.vala"
	_tmp14_ = (GtkActionBar*) gtk_action_bar_new ();
#line 318 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp14_);
#line 318 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->actionbar);
#line 318 "../src/Views/FirewallPanel.vala"
	self->priv->actionbar = _tmp14_;
#line 319 "../src/Views/FirewallPanel.vala"
	_tmp15_ = self->priv->actionbar;
#line 319 "../src/Views/FirewallPanel.vala"
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
#line 319 "../src/Views/FirewallPanel.vala"
	gtk_style_context_add_class (_tmp16_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
#line 321 "../src/Views/FirewallPanel.vala"
	_tmp17_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 321 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp17_);
#line 321 "../src/Views/FirewallPanel.vala"
	_data4_->add_button = _tmp17_;
#line 323 "../src/Views/FirewallPanel.vala"
	g_signal_connect_data (_data4_->add_button, "clicked", (GCallback) ___lambda11__gtk_button_clicked, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 426 "../src/Views/FirewallPanel.vala"
	_tmp18_ = self->priv->actionbar;
#line 426 "../src/Views/FirewallPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _data4_->add_button);
#line 427 "../src/Views/FirewallPanel.vala"
	_tmp19_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 427 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp19_);
#line 427 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->remove_button);
#line 427 "../src/Views/FirewallPanel.vala"
	self->priv->remove_button = _tmp19_;
#line 428 "../src/Views/FirewallPanel.vala"
	_tmp20_ = self->priv->remove_button;
#line 428 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, FALSE);
#line 429 "../src/Views/FirewallPanel.vala"
	_tmp21_ = self->priv->remove_button;
#line 429 "../src/Views/FirewallPanel.vala"
	g_signal_connect_object (_tmp21_, "clicked", (GCallback) ___lambda13__gtk_button_clicked, self, 0);
#line 448 "../src/Views/FirewallPanel.vala"
	_tmp22_ = self->priv->actionbar;
#line 448 "../src/Views/FirewallPanel.vala"
	_tmp23_ = self->priv->remove_button;
#line 448 "../src/Views/FirewallPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 450 "../src/Views/FirewallPanel.vala"
	_tmp24_ = self->priv->view;
#line 450 "../src/Views/FirewallPanel.vala"
	g_signal_connect_object (_tmp24_, "cursor-changed", (GCallback) ___lambda14__gtk_tree_view_cursor_changed, self, 0);
#line 454 "../src/Views/FirewallPanel.vala"
	_tmp25_ = (GtkGrid*) gtk_grid_new ();
#line 454 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp25_);
#line 454 "../src/Views/FirewallPanel.vala"
	view_grid = _tmp25_;
#line 456 "../src/Views/FirewallPanel.vala"
	_tmp26_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 456 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp26_);
#line 456 "../src/Views/FirewallPanel.vala"
	scrolled = _tmp26_;
#line 457 "../src/Views/FirewallPanel.vala"
	g_object_set ((GtkWidget*) scrolled, "expand", TRUE, NULL);
#line 458 "../src/Views/FirewallPanel.vala"
	_tmp27_ = self->priv->view;
#line 458 "../src/Views/FirewallPanel.vala"
	gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) _tmp27_);
#line 460 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (view_grid, (GtkWidget*) scrolled, 0, 0, 1, 1);
#line 461 "../src/Views/FirewallPanel.vala"
	_tmp28_ = self->priv->actionbar;
#line 461 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (view_grid, (GtkWidget*) _tmp28_, 0, 1, 1, 1);
#line 463 "../src/Views/FirewallPanel.vala"
	_tmp29_ = (GtkFrame*) gtk_frame_new (NULL);
#line 463 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp29_);
#line 463 "../src/Views/FirewallPanel.vala"
	frame = _tmp29_;
#line 464 "../src/Views/FirewallPanel.vala"
	gtk_container_add ((GtkContainer*) frame, (GtkWidget*) view_grid);
#line 466 "../src/Views/FirewallPanel.vala"
	_tmp30_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 466 "../src/Views/FirewallPanel.vala"
	_tmp31_ = _tmp30_;
#line 466 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (_tmp31_, (GtkWidget*) frame, 0, 1, 3, 1);
#line 272 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (frame);
#line 272 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (scrolled);
#line 272 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (view_grid);
#line 272 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (cell);
#line 272 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (celltoggle);
#line 272 "../src/Views/FirewallPanel.vala"
	block4_data_unref (_data4_);
#line 272 "../src/Views/FirewallPanel.vala"
	_data4_ = NULL;
#line 2787 "FirewallPanel.c"
}

static void
_security_privacy_firewall_panel___lambda15_ (SecurityPrivacyFirewallPanel* self)
{
	GtkSwitch* _tmp9_;
	GtkSwitch* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 57 "../src/Views/FirewallPanel.vala"
	if (self->priv->loading == FALSE) {
#line 2799 "FirewallPanel.c"
		GtkTreeView* _tmp0_;
		GtkSwitch* _tmp1_;
		GtkSwitch* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		GtkSwitch* _tmp5_;
		GtkSwitch* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 58 "../src/Views/FirewallPanel.vala"
		_tmp0_ = self->priv->view;
#line 58 "../src/Views/FirewallPanel.vala"
		_tmp1_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 58 "../src/Views/FirewallPanel.vala"
		_tmp2_ = _tmp1_;
#line 58 "../src/Views/FirewallPanel.vala"
		_tmp3_ = gtk_switch_get_active (_tmp2_);
#line 58 "../src/Views/FirewallPanel.vala"
		_tmp4_ = _tmp3_;
#line 58 "../src/Views/FirewallPanel.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp4_);
#line 59 "../src/Views/FirewallPanel.vala"
		_tmp5_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 59 "../src/Views/FirewallPanel.vala"
		_tmp6_ = _tmp5_;
#line 59 "../src/Views/FirewallPanel.vala"
		_tmp7_ = gtk_switch_get_active (_tmp6_);
#line 59 "../src/Views/FirewallPanel.vala"
		_tmp8_ = _tmp7_;
#line 59 "../src/Views/FirewallPanel.vala"
		security_privacy_ufw_helpers_set_status (_tmp8_);
#line 2831 "FirewallPanel.c"
	}
#line 62 "../src/Views/FirewallPanel.vala"
	_tmp9_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 62 "../src/Views/FirewallPanel.vala"
	_tmp10_ = _tmp9_;
#line 62 "../src/Views/FirewallPanel.vala"
	_tmp11_ = gtk_switch_get_active (_tmp10_);
#line 62 "../src/Views/FirewallPanel.vala"
	_tmp12_ = _tmp11_;
#line 62 "../src/Views/FirewallPanel.vala"
	if (_tmp12_) {
#line 63 "../src/Views/FirewallPanel.vala"
		granite_settings_page_set_status_type ((GraniteSettingsPage*) self, GRANITE_SETTINGS_PAGE_STATUS_TYPE_SUCCESS);
#line 64 "../src/Views/FirewallPanel.vala"
		granite_settings_page_set_status ((GraniteSettingsPage*) self, _ ("Enabled"));
#line 2847 "FirewallPanel.c"
	} else {
#line 66 "../src/Views/FirewallPanel.vala"
		g_warning ("FirewallPanel.vala:66: Trying to set offline");
#line 67 "../src/Views/FirewallPanel.vala"
		granite_settings_page_set_status_type ((GraniteSettingsPage*) self, GRANITE_SETTINGS_PAGE_STATUS_TYPE_OFFLINE);
#line 68 "../src/Views/FirewallPanel.vala"
		granite_settings_page_set_status ((GraniteSettingsPage*) self, _ ("Disabled"));
#line 2855 "FirewallPanel.c"
	}
#line 71 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_show_rules (self);
#line 2859 "FirewallPanel.c"
}

static void
__security_privacy_firewall_panel___lambda15__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 56 "../src/Views/FirewallPanel.vala"
	_security_privacy_firewall_panel___lambda15_ ((SecurityPrivacyFirewallPanel*) self);
#line 2869 "FirewallPanel.c"
}

static void
_security_privacy_firewall_panel___lambda16_ (SecurityPrivacyFirewallPanel* self)
{
	GtkLockButton* _tmp0_;
	GPermission* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkSwitch* _tmp4_;
	GtkSwitch* _tmp5_;
	GtkListStore* _tmp6_;
	GtkButton* _tmp7_;
	GtkSwitch* _tmp8_;
	GtkSwitch* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
#line 79 "../src/Views/FirewallPanel.vala"
	self->priv->loading = TRUE;
#line 80 "../src/Views/FirewallPanel.vala"
	_tmp0_ = security_privacy_lock_button;
#line 80 "../src/Views/FirewallPanel.vala"
	_tmp1_ = gtk_lock_button_get_permission (_tmp0_);
#line 80 "../src/Views/FirewallPanel.vala"
	_tmp2_ = g_permission_get_allowed (_tmp1_);
#line 80 "../src/Views/FirewallPanel.vala"
	_tmp3_ = _tmp2_;
#line 80 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp3_);
#line 81 "../src/Views/FirewallPanel.vala"
	_tmp4_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 81 "../src/Views/FirewallPanel.vala"
	_tmp5_ = _tmp4_;
#line 81 "../src/Views/FirewallPanel.vala"
	gtk_switch_set_active (_tmp5_, security_privacy_ufw_helpers_get_status ());
#line 82 "../src/Views/FirewallPanel.vala"
	_tmp6_ = self->priv->list_store;
#line 82 "../src/Views/FirewallPanel.vala"
	gtk_list_store_clear (_tmp6_);
#line 83 "../src/Views/FirewallPanel.vala"
	_tmp7_ = self->priv->remove_button;
#line 83 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 84 "../src/Views/FirewallPanel.vala"
	_tmp8_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 84 "../src/Views/FirewallPanel.vala"
	_tmp9_ = _tmp8_;
#line 84 "../src/Views/FirewallPanel.vala"
	_tmp10_ = gtk_switch_get_active (_tmp9_);
#line 84 "../src/Views/FirewallPanel.vala"
	_tmp11_ = _tmp10_;
#line 84 "../src/Views/FirewallPanel.vala"
	if (_tmp11_ == TRUE) {
#line 2923 "FirewallPanel.c"
		GtkTreeView* _tmp12_;
#line 85 "../src/Views/FirewallPanel.vala"
		_tmp12_ = self->priv->view;
#line 85 "../src/Views/FirewallPanel.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, TRUE);
#line 86 "../src/Views/FirewallPanel.vala"
		security_privacy_firewall_panel_show_rules (self);
#line 2931 "FirewallPanel.c"
	} else {
		GtkTreeView* _tmp13_;
#line 88 "../src/Views/FirewallPanel.vala"
		_tmp13_ = self->priv->view;
#line 88 "../src/Views/FirewallPanel.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, FALSE);
#line 2938 "FirewallPanel.c"
	}
#line 90 "../src/Views/FirewallPanel.vala"
	self->priv->loading = FALSE;
#line 2942 "FirewallPanel.c"
}

static void
__security_privacy_firewall_panel___lambda16__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 78 "../src/Views/FirewallPanel.vala"
	_security_privacy_firewall_panel___lambda16_ ((SecurityPrivacyFirewallPanel*) self);
#line 2952 "FirewallPanel.c"
}

static GObject *
security_privacy_firewall_panel_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SecurityPrivacyFirewallPanel * self;
	GSettings* _tmp0_;
	GeeHashMap* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkLockButton* _tmp4_;
	GPermission* _tmp5_;
#line 51 "../src/Views/FirewallPanel.vala"
	parent_class = G_OBJECT_CLASS (security_privacy_firewall_panel_parent_class);
#line 51 "../src/Views/FirewallPanel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../src/Views/FirewallPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_FIREWALL_PANEL, SecurityPrivacyFirewallPanel);
#line 52 "../src/Views/FirewallPanel.vala"
	_tmp0_ = g_settings_new ("io.elementary.switchboard.security-privacy");
#line 52 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->settings);
#line 52 "../src/Views/FirewallPanel.vala"
	self->priv->settings = _tmp0_;
#line 53 "../src/Views/FirewallPanel.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 53 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->disabled_rules);
#line 53 "../src/Views/FirewallPanel.vala"
	self->priv->disabled_rules = _tmp1_;
#line 54 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_load_disabled_rules (self);
#line 56 "../src/Views/FirewallPanel.vala"
	_tmp2_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 56 "../src/Views/FirewallPanel.vala"
	_tmp3_ = _tmp2_;
#line 56 "../src/Views/FirewallPanel.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::active", (GCallback) __security_privacy_firewall_panel___lambda15__g_object_notify, self, 0);
#line 74 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_create_treeview (self);
#line 76 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
#line 78 "../src/Views/FirewallPanel.vala"
	_tmp4_ = security_privacy_lock_button;
#line 78 "../src/Views/FirewallPanel.vala"
	_tmp5_ = gtk_lock_button_get_permission (_tmp4_);
#line 78 "../src/Views/FirewallPanel.vala"
	g_signal_connect_object ((GObject*) _tmp5_, "notify::allowed", (GCallback) __security_privacy_firewall_panel___lambda16__g_object_notify, self, 0);
#line 51 "../src/Views/FirewallPanel.vala"
	return obj;
#line 3007 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_class_init (SecurityPrivacyFirewallPanelClass * klass,
                                            gpointer klass_data)
{
#line 23 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Views/FirewallPanel.vala"
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyFirewallPanel_private_offset);
#line 23 "../src/Views/FirewallPanel.vala"
	G_OBJECT_CLASS (klass)->constructor = security_privacy_firewall_panel_constructor;
#line 23 "../src/Views/FirewallPanel.vala"
	G_OBJECT_CLASS (klass)->finalize = security_privacy_firewall_panel_finalize;
#line 3022 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_instance_init (SecurityPrivacyFirewallPanel * self,
                                               gpointer klass)
{
#line 23 "../src/Views/FirewallPanel.vala"
	self->priv = security_privacy_firewall_panel_get_instance_private (self);
#line 27 "../src/Views/FirewallPanel.vala"
	self->priv->loading = FALSE;
#line 3033 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_finalize (GObject * obj)
{
	SecurityPrivacyFirewallPanel * self;
#line 23 "../src/Views/FirewallPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_FIREWALL_PANEL, SecurityPrivacyFirewallPanel);
#line 24 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->list_store);
#line 25 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->view);
#line 26 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->actionbar);
#line 28 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->add_popover);
#line 29 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->remove_button);
#line 30 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->settings);
#line 31 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->disabled_rules);
#line 23 "../src/Views/FirewallPanel.vala"
	G_OBJECT_CLASS (security_privacy_firewall_panel_parent_class)->finalize (obj);
#line 3058 "FirewallPanel.c"
}

static GType
security_privacy_firewall_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyFirewallPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_firewall_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyFirewallPanel), 0, (GInstanceInitFunc) security_privacy_firewall_panel_instance_init, NULL };
	GType security_privacy_firewall_panel_type_id;
	security_privacy_firewall_panel_type_id = g_type_register_static (GRANITE_TYPE_SIMPLE_SETTINGS_PAGE, "SecurityPrivacyFirewallPanel", &g_define_type_info, 0);
	SecurityPrivacyFirewallPanel_private_offset = g_type_add_instance_private (security_privacy_firewall_panel_type_id, sizeof (SecurityPrivacyFirewallPanelPrivate));
	return security_privacy_firewall_panel_type_id;
}

GType
security_privacy_firewall_panel_get_type (void)
{
	static volatile gsize security_privacy_firewall_panel_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_firewall_panel_type_id__once)) {
		GType security_privacy_firewall_panel_type_id;
		security_privacy_firewall_panel_type_id = security_privacy_firewall_panel_get_type_once ();
		g_once_init_leave (&security_privacy_firewall_panel_type_id__once, security_privacy_firewall_panel_type_id);
	}
	return security_privacy_firewall_panel_type_id__once;
}

