/* LockPanel.c generated by valac 0.56.14, the Vala compiler
 * generated from LockPanel.vala, do not modify */

/*-
 * Copyright 2014-2020 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "security-privacy.h"
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <gio/gio.h>

enum  {
	SECURITY_PRIVACY_LOCK_PANEL_0_PROPERTY,
	SECURITY_PRIVACY_LOCK_PANEL_NUM_PROPERTIES
};
static GParamSpec* security_privacy_lock_panel_properties[SECURITY_PRIVACY_LOCK_PANEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))

static gpointer security_privacy_lock_panel_parent_class = NULL;

static GObject * security_privacy_lock_panel_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static GType security_privacy_lock_panel_get_type_once (void);

SecurityPrivacyLockPanel*
security_privacy_lock_panel_construct (GType object_type)
{
	SecurityPrivacyLockPanel * self = NULL;
#line 24 "../src/Views/LockPanel.vala"
	self = (SecurityPrivacyLockPanel*) g_object_new (object_type, "icon-name", "system-lock-screen", "title", _ ("Locking"), NULL);
#line 23 "../src/Views/LockPanel.vala"
	return self;
#line 57 "LockPanel.c"
}

SecurityPrivacyLockPanel*
security_privacy_lock_panel_new (void)
{
#line 23 "../src/Views/LockPanel.vala"
	return security_privacy_lock_panel_construct (SECURITY_PRIVACY_TYPE_LOCK_PANEL);
#line 65 "LockPanel.c"
}

static GObject *
security_privacy_lock_panel_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SecurityPrivacyLockPanel * self;
	GtkLabel* lock_suspend_label = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkSwitch* lock_suspend_switch = NULL;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkLabel* lock_sleep_label = NULL;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkSwitch* lock_sleep_switch = NULL;
	GtkSwitch* _tmp6_;
	GtkSwitch* _tmp7_;
	GtkGrid* _tmp8_;
	GtkGrid* _tmp9_;
	GtkGrid* _tmp10_;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkLabel* _tmp14_;
	GtkGrid* _tmp15_;
	GtkGrid* _tmp16_;
	GtkSwitch* _tmp17_;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GtkLabel* _tmp20_;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	GtkSwitch* _tmp23_;
	GSettings* gnome_screensaver_settings = NULL;
	GSettings* _tmp24_;
	GSettings* screensaver_settings = NULL;
	GSettings* _tmp25_;
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp26_;
	GSettingsSchema* _tmp27_;
	GSettingsSchema* _tmp28_;
	GSettings* _tmp42_;
	GtkSwitch* _tmp43_;
	GSettings* _tmp44_;
	GtkSwitch* _tmp45_;
#line 30 "../src/Views/LockPanel.vala"
	parent_class = G_OBJECT_CLASS (security_privacy_lock_panel_parent_class);
#line 30 "../src/Views/LockPanel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "../src/Views/LockPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_LOCK_PANEL, SecurityPrivacyLockPanel);
#line 31 "../src/Views/LockPanel.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Lock on suspend:"));
#line 31 "../src/Views/LockPanel.vala"
	g_object_ref_sink (_tmp0_);
#line 31 "../src/Views/LockPanel.vala"
	lock_suspend_label = _tmp0_;
#line 32 "../src/Views/LockPanel.vala"
	_tmp1_ = lock_suspend_label;
#line 32 "../src/Views/LockPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_END);
#line 34 "../src/Views/LockPanel.vala"
	_tmp2_ = (GtkSwitch*) gtk_switch_new ();
#line 34 "../src/Views/LockPanel.vala"
	g_object_ref_sink (_tmp2_);
#line 34 "../src/Views/LockPanel.vala"
	lock_suspend_switch = _tmp2_;
#line 35 "../src/Views/LockPanel.vala"
	_tmp3_ = lock_suspend_switch;
#line 35 "../src/Views/LockPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 37 "../src/Views/LockPanel.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (_ ("Lock after screen turns off:"));
#line 37 "../src/Views/LockPanel.vala"
	g_object_ref_sink (_tmp4_);
#line 37 "../src/Views/LockPanel.vala"
	lock_sleep_label = _tmp4_;
#line 38 "../src/Views/LockPanel.vala"
	_tmp5_ = lock_sleep_label;
#line 38 "../src/Views/LockPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
#line 40 "../src/Views/LockPanel.vala"
	_tmp6_ = (GtkSwitch*) gtk_switch_new ();
#line 40 "../src/Views/LockPanel.vala"
	g_object_ref_sink (_tmp6_);
#line 40 "../src/Views/LockPanel.vala"
	lock_sleep_switch = _tmp6_;
#line 41 "../src/Views/LockPanel.vala"
	_tmp7_ = lock_sleep_switch;
#line 41 "../src/Views/LockPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
#line 43 "../src/Views/LockPanel.vala"
	_tmp8_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 43 "../src/Views/LockPanel.vala"
	_tmp9_ = _tmp8_;
#line 43 "../src/Views/LockPanel.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp9_, TRUE);
#line 44 "../src/Views/LockPanel.vala"
	_tmp10_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 44 "../src/Views/LockPanel.vala"
	_tmp11_ = _tmp10_;
#line 44 "../src/Views/LockPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_CENTER);
#line 45 "../src/Views/LockPanel.vala"
	_tmp12_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 45 "../src/Views/LockPanel.vala"
	_tmp13_ = _tmp12_;
#line 45 "../src/Views/LockPanel.vala"
	_tmp14_ = lock_suspend_label;
#line 45 "../src/Views/LockPanel.vala"
	gtk_grid_attach (_tmp13_, (GtkWidget*) _tmp14_, 0, 0, 1, 1);
#line 46 "../src/Views/LockPanel.vala"
	_tmp15_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 46 "../src/Views/LockPanel.vala"
	_tmp16_ = _tmp15_;
#line 46 "../src/Views/LockPanel.vala"
	_tmp17_ = lock_suspend_switch;
#line 46 "../src/Views/LockPanel.vala"
	gtk_grid_attach (_tmp16_, (GtkWidget*) _tmp17_, 1, 0, 1, 1);
#line 47 "../src/Views/LockPanel.vala"
	_tmp18_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 47 "../src/Views/LockPanel.vala"
	_tmp19_ = _tmp18_;
#line 47 "../src/Views/LockPanel.vala"
	_tmp20_ = lock_sleep_label;
#line 47 "../src/Views/LockPanel.vala"
	gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 0, 1, 1, 1);
#line 48 "../src/Views/LockPanel.vala"
	_tmp21_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 48 "../src/Views/LockPanel.vala"
	_tmp22_ = _tmp21_;
#line 48 "../src/Views/LockPanel.vala"
	_tmp23_ = lock_sleep_switch;
#line 48 "../src/Views/LockPanel.vala"
	gtk_grid_attach (_tmp22_, (GtkWidget*) _tmp23_, 1, 1, 1, 1);
#line 50 "../src/Views/LockPanel.vala"
	_tmp24_ = g_settings_new ("org.gnome.desktop.screensaver");
#line 50 "../src/Views/LockPanel.vala"
	gnome_screensaver_settings = _tmp24_;
#line 51 "../src/Views/LockPanel.vala"
	_tmp25_ = g_settings_new ("io.elementary.desktop.screensaver");
#line 51 "../src/Views/LockPanel.vala"
	screensaver_settings = _tmp25_;
#line 53 "../src/Views/LockPanel.vala"
	_tmp26_ = g_settings_schema_source_get_default ();
#line 53 "../src/Views/LockPanel.vala"
	_tmp27_ = g_settings_schema_source_lookup (_tmp26_, "org.gnome.desktop.privacy", TRUE);
#line 53 "../src/Views/LockPanel.vala"
	schema = _tmp27_;
#line 54 "../src/Views/LockPanel.vala"
	_tmp28_ = schema;
#line 54 "../src/Views/LockPanel.vala"
	if (g_settings_schema_has_key (_tmp28_, "usb-protection")) {
#line 224 "LockPanel.c"
		GtkLabel* usb_lock_label = NULL;
		GtkLabel* _tmp29_;
		GtkLabel* _tmp30_;
		GtkSwitch* usb_lock_switch = NULL;
		GtkSwitch* _tmp31_;
		GtkSwitch* _tmp32_;
		GtkGrid* _tmp33_;
		GtkGrid* _tmp34_;
		GtkLabel* _tmp35_;
		GtkGrid* _tmp36_;
		GtkGrid* _tmp37_;
		GtkSwitch* _tmp38_;
		GSettings* gnome_privacy_settings = NULL;
		GSettings* _tmp39_;
		GSettings* _tmp40_;
		GtkSwitch* _tmp41_;
#line 55 "../src/Views/LockPanel.vala"
		_tmp29_ = (GtkLabel*) gtk_label_new (_ ("Forbid new USB devices when locked:"));
#line 55 "../src/Views/LockPanel.vala"
		g_object_ref_sink (_tmp29_);
#line 55 "../src/Views/LockPanel.vala"
		usb_lock_label = _tmp29_;
#line 56 "../src/Views/LockPanel.vala"
		_tmp30_ = usb_lock_label;
#line 56 "../src/Views/LockPanel.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp30_, GTK_ALIGN_END);
#line 58 "../src/Views/LockPanel.vala"
		_tmp31_ = (GtkSwitch*) gtk_switch_new ();
#line 58 "../src/Views/LockPanel.vala"
		g_object_ref_sink (_tmp31_);
#line 58 "../src/Views/LockPanel.vala"
		usb_lock_switch = _tmp31_;
#line 59 "../src/Views/LockPanel.vala"
		_tmp32_ = usb_lock_switch;
#line 59 "../src/Views/LockPanel.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp32_, GTK_ALIGN_START);
#line 61 "../src/Views/LockPanel.vala"
		_tmp33_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 61 "../src/Views/LockPanel.vala"
		_tmp34_ = _tmp33_;
#line 61 "../src/Views/LockPanel.vala"
		_tmp35_ = usb_lock_label;
#line 61 "../src/Views/LockPanel.vala"
		gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp35_, 0, 2, 1, 1);
#line 62 "../src/Views/LockPanel.vala"
		_tmp36_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 62 "../src/Views/LockPanel.vala"
		_tmp37_ = _tmp36_;
#line 62 "../src/Views/LockPanel.vala"
		_tmp38_ = usb_lock_switch;
#line 62 "../src/Views/LockPanel.vala"
		gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 1, 2, 1, 1);
#line 63 "../src/Views/LockPanel.vala"
		_tmp39_ = g_settings_new ("org.gnome.desktop.privacy");
#line 63 "../src/Views/LockPanel.vala"
		gnome_privacy_settings = _tmp39_;
#line 64 "../src/Views/LockPanel.vala"
		_tmp40_ = gnome_privacy_settings;
#line 64 "../src/Views/LockPanel.vala"
		_tmp41_ = usb_lock_switch;
#line 64 "../src/Views/LockPanel.vala"
		g_settings_bind (_tmp40_, "usb-protection", (GObject*) _tmp41_, "active", G_SETTINGS_BIND_DEFAULT);
#line 54 "../src/Views/LockPanel.vala"
		_g_object_unref0 (gnome_privacy_settings);
#line 54 "../src/Views/LockPanel.vala"
		_g_object_unref0 (usb_lock_switch);
#line 54 "../src/Views/LockPanel.vala"
		_g_object_unref0 (usb_lock_label);
#line 293 "LockPanel.c"
	}
#line 67 "../src/Views/LockPanel.vala"
	_tmp42_ = gnome_screensaver_settings;
#line 67 "../src/Views/LockPanel.vala"
	_tmp43_ = lock_sleep_switch;
#line 67 "../src/Views/LockPanel.vala"
	g_settings_bind (_tmp42_, "lock-enabled", (GObject*) _tmp43_, "active", G_SETTINGS_BIND_DEFAULT);
#line 68 "../src/Views/LockPanel.vala"
	_tmp44_ = screensaver_settings;
#line 68 "../src/Views/LockPanel.vala"
	_tmp45_ = lock_suspend_switch;
#line 68 "../src/Views/LockPanel.vala"
	g_settings_bind (_tmp44_, "lock-on-suspend", (GObject*) _tmp45_, "active", G_SETTINGS_BIND_DEFAULT);
#line 30 "../src/Views/LockPanel.vala"
	_g_settings_schema_unref0 (schema);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (screensaver_settings);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (gnome_screensaver_settings);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (lock_sleep_switch);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (lock_sleep_label);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (lock_suspend_switch);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (lock_suspend_label);
#line 30 "../src/Views/LockPanel.vala"
	return obj;
#line 323 "LockPanel.c"
}

static void
security_privacy_lock_panel_class_init (SecurityPrivacyLockPanelClass * klass,
                                        gpointer klass_data)
{
#line 22 "../src/Views/LockPanel.vala"
	security_privacy_lock_panel_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Views/LockPanel.vala"
	G_OBJECT_CLASS (klass)->constructor = security_privacy_lock_panel_constructor;
#line 334 "LockPanel.c"
}

static void
security_privacy_lock_panel_instance_init (SecurityPrivacyLockPanel * self,
                                           gpointer klass)
{
}

static GType
security_privacy_lock_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyLockPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_lock_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyLockPanel), 0, (GInstanceInitFunc) security_privacy_lock_panel_instance_init, NULL };
	GType security_privacy_lock_panel_type_id;
	security_privacy_lock_panel_type_id = g_type_register_static (GRANITE_TYPE_SIMPLE_SETTINGS_PAGE, "SecurityPrivacyLockPanel", &g_define_type_info, 0);
	return security_privacy_lock_panel_type_id;
}

GType
security_privacy_lock_panel_get_type (void)
{
	static volatile gsize security_privacy_lock_panel_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_lock_panel_type_id__once)) {
		GType security_privacy_lock_panel_type_id;
		security_privacy_lock_panel_type_id = security_privacy_lock_panel_get_type_once ();
		g_once_init_leave (&security_privacy_lock_panel_type_id__once, security_privacy_lock_panel_type_id);
	}
	return security_privacy_lock_panel_type_id__once;
}

