/* TrackPanel.c generated by valac 0.56.14, the Vala compiler
 * generated from TrackPanel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2014-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 */

#include "security-privacy.h"
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

enum  {
	SECURITY_PRIVACY_TRACK_PANEL_0_PROPERTY,
	SECURITY_PRIVACY_TRACK_PANEL_NUM_PROPERTIES
};
static GParamSpec* security_privacy_track_panel_properties[SECURITY_PRIVACY_TRACK_PANEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _security_privacy_blacklist_unref0(var) ((var == NULL) ? NULL : (var = (security_privacy_blacklist_unref (var), NULL)))
typedef struct _Block7Data Block7Data;

struct _SecurityPrivacyTrackPanelPrivate {
	SecurityPrivacyWidgetsClearUsagePopover* remove_popover;
};

struct _Block7Data {
	int _ref_count_;
	SecurityPrivacyTrackPanel* self;
	GtkFrame* description_frame;
	GtkToggleButton* clear_data;
	IncludeTreeView* include_treeview;
	ExcludeTreeView* exclude_treeview;
};

static gint SecurityPrivacyTrackPanel_private_offset;
static gpointer security_privacy_track_panel_parent_class = NULL;
static SecurityPrivacyBlacklist* security_privacy_track_panel__blacklist;
static SecurityPrivacyBlacklist* security_privacy_track_panel__blacklist = NULL;

static gchar* security_privacy_track_panel_get_operating_system_name (void);
static void security_privacy_track_panel_update_status_switch (SecurityPrivacyTrackPanel* self);
static void security_privacy_track_panel_set_blacklist (SecurityPrivacyBlacklist* value);
static GObject * security_privacy_track_panel_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _security_privacy_track_panel___lambda20_ (Block7Data* _data7_);
static void __security_privacy_track_panel___lambda20__g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void _security_privacy_track_panel___lambda21_ (Block7Data* _data7_);
static void __security_privacy_track_panel___lambda21__gtk_popover_closed (GtkPopover* _sender,
                                                                    gpointer self);
static void _security_privacy_track_panel___lambda30_ (Block7Data* _data7_);
static void __security_privacy_track_panel___lambda30__g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void security_privacy_track_panel_finalize (GObject * obj);
static GType security_privacy_track_panel_get_type_once (void);
static void _vala_security_privacy_track_panel_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_security_privacy_track_panel_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);

static inline gpointer
security_privacy_track_panel_get_instance_private (SecurityPrivacyTrackPanel* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyTrackPanel_private_offset);
}

SecurityPrivacyTrackPanel*
security_privacy_track_panel_construct (GType object_type)
{
	SecurityPrivacyTrackPanel * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 29 "../src/Views/TrackPanel.vala"
	_tmp0_ = security_privacy_track_panel_get_operating_system_name ();
#line 29 "../src/Views/TrackPanel.vala"
	_tmp1_ = _tmp0_;
#line 29 "../src/Views/TrackPanel.vala"
	_tmp2_ = g_strdup_printf (_ ("%s can store local usage data to provide extra functionality like offe" \
"ring recently-used files and more relevant local search. Regardless of" \
" this setting, usage data is never transmitted off of this device or t" \
"o third parties."), _tmp1_);
#line 29 "../src/Views/TrackPanel.vala"
	_tmp3_ = _tmp2_;
#line 29 "../src/Views/TrackPanel.vala"
	self = (SecurityPrivacyTrackPanel*) g_object_new (object_type, "activatable", TRUE, "description", _tmp3_, "icon-name", "document-open-recent", "title", _ ("History"), NULL);
#line 29 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp3_);
#line 29 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp1_);
#line 28 "../src/Views/TrackPanel.vala"
	return self;
#line 125 "TrackPanel.c"
}

SecurityPrivacyTrackPanel*
security_privacy_track_panel_new (void)
{
#line 28 "../src/Views/TrackPanel.vala"
	return security_privacy_track_panel_construct (SECURITY_PRIVACY_TYPE_TRACK_PANEL);
#line 133 "TrackPanel.c"
}

static gchar*
security_privacy_track_panel_get_operating_system_name (void)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp3_;
	gchar* result;
#line 103 "../src/Views/TrackPanel.vala"
	_tmp1_ = g_get_os_info (G_OS_INFO_KEY_NAME);
#line 103 "../src/Views/TrackPanel.vala"
	_tmp0_ = _tmp1_;
#line 103 "../src/Views/TrackPanel.vala"
	if (_tmp0_ == NULL) {
#line 149 "TrackPanel.c"
		gchar* _tmp2_;
#line 103 "../src/Views/TrackPanel.vala"
		_tmp2_ = g_strdup (_ ("Your system"));
#line 103 "../src/Views/TrackPanel.vala"
		_g_free0 (_tmp0_);
#line 103 "../src/Views/TrackPanel.vala"
		_tmp0_ = _tmp2_;
#line 157 "TrackPanel.c"
	}
#line 103 "../src/Views/TrackPanel.vala"
	_tmp3_ = _tmp0_;
#line 103 "../src/Views/TrackPanel.vala"
	_tmp0_ = NULL;
#line 103 "../src/Views/TrackPanel.vala"
	result = _tmp3_;
#line 103 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp0_);
#line 103 "../src/Views/TrackPanel.vala"
	return result;
#line 169 "TrackPanel.c"
}

static void
security_privacy_track_panel_update_status_switch (SecurityPrivacyTrackPanel* self)
{
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 106 "../src/Views/TrackPanel.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/Views/TrackPanel.vala"
	_tmp0_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 107 "../src/Views/TrackPanel.vala"
	_tmp1_ = _tmp0_;
#line 107 "../src/Views/TrackPanel.vala"
	_tmp2_ = gtk_switch_get_active (_tmp1_);
#line 107 "../src/Views/TrackPanel.vala"
	_tmp3_ = _tmp2_;
#line 107 "../src/Views/TrackPanel.vala"
	if (_tmp3_) {
#line 108 "../src/Views/TrackPanel.vala"
		granite_settings_page_set_status_type ((GraniteSettingsPage*) self, GRANITE_SETTINGS_PAGE_STATUS_TYPE_SUCCESS);
#line 109 "../src/Views/TrackPanel.vala"
		granite_settings_page_set_status ((GraniteSettingsPage*) self, _ ("Enabled"));
#line 195 "TrackPanel.c"
	} else {
#line 111 "../src/Views/TrackPanel.vala"
		g_warning ("TrackPanel.vala:111: Trying to set offline");
#line 112 "../src/Views/TrackPanel.vala"
		granite_settings_page_set_status_type ((GraniteSettingsPage*) self, GRANITE_SETTINGS_PAGE_STATUS_TYPE_OFFLINE);
#line 113 "../src/Views/TrackPanel.vala"
		granite_settings_page_set_status ((GraniteSettingsPage*) self, _ ("Disabled"));
#line 203 "TrackPanel.c"
	}
}

SecurityPrivacyBlacklist*
security_privacy_track_panel_get_blacklist (void)
{
	SecurityPrivacyBlacklist* result;
	SecurityPrivacyBlacklist* _tmp0_;
#line 24 "../src/Views/TrackPanel.vala"
	_tmp0_ = security_privacy_track_panel__blacklist;
#line 24 "../src/Views/TrackPanel.vala"
	result = _tmp0_;
#line 24 "../src/Views/TrackPanel.vala"
	return result;
#line 218 "TrackPanel.c"
}

static gpointer
_security_privacy_blacklist_ref0 (gpointer self)
{
#line 24 "../src/Views/TrackPanel.vala"
	return self ? security_privacy_blacklist_ref (self) : NULL;
#line 226 "TrackPanel.c"
}

static void
security_privacy_track_panel_set_blacklist (SecurityPrivacyBlacklist* value)
{
	SecurityPrivacyBlacklist* _tmp0_;
#line 24 "../src/Views/TrackPanel.vala"
	_tmp0_ = _security_privacy_blacklist_ref0 (value);
#line 24 "../src/Views/TrackPanel.vala"
	_security_privacy_blacklist_unref0 (security_privacy_track_panel__blacklist);
#line 24 "../src/Views/TrackPanel.vala"
	security_privacy_track_panel__blacklist = _tmp0_;
#line 239 "TrackPanel.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 41 "../src/Views/TrackPanel.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 41 "../src/Views/TrackPanel.vala"
	return _data7_;
#line 249 "TrackPanel.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 41 "../src/Views/TrackPanel.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 259 "TrackPanel.c"
		SecurityPrivacyTrackPanel* self;
#line 41 "../src/Views/TrackPanel.vala"
		self = _data7_->self;
#line 41 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (_data7_->exclude_treeview);
#line 41 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (_data7_->include_treeview);
#line 41 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (_data7_->clear_data);
#line 41 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (_data7_->description_frame);
#line 41 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (self);
#line 41 "../src/Views/TrackPanel.vala"
		g_slice_free (Block7Data, _data7_);
#line 275 "TrackPanel.c"
	}
}

static void
_security_privacy_track_panel___lambda20_ (Block7Data* _data7_)
{
	SecurityPrivacyTrackPanel* self;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 58 "../src/Views/TrackPanel.vala"
	self = _data7_->self;
#line 59 "../src/Views/TrackPanel.vala"
	_tmp0_ = _data7_->clear_data;
#line 59 "../src/Views/TrackPanel.vala"
	_tmp1_ = gtk_toggle_button_get_active (_tmp0_);
#line 59 "../src/Views/TrackPanel.vala"
	_tmp2_ = _tmp1_;
#line 59 "../src/Views/TrackPanel.vala"
	if (_tmp2_ == FALSE) {
#line 296 "TrackPanel.c"
		SecurityPrivacyWidgetsClearUsagePopover* _tmp3_;
#line 60 "../src/Views/TrackPanel.vala"
		_tmp3_ = self->priv->remove_popover;
#line 60 "../src/Views/TrackPanel.vala"
		gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 302 "TrackPanel.c"
	} else {
		SecurityPrivacyWidgetsClearUsagePopover* _tmp4_;
#line 62 "../src/Views/TrackPanel.vala"
		_tmp4_ = self->priv->remove_popover;
#line 62 "../src/Views/TrackPanel.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp4_);
#line 309 "TrackPanel.c"
	}
}

static void
__security_privacy_track_panel___lambda20__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
#line 58 "../src/Views/TrackPanel.vala"
	_security_privacy_track_panel___lambda20_ (self);
#line 320 "TrackPanel.c"
}

static void
_security_privacy_track_panel___lambda21_ (Block7Data* _data7_)
{
	SecurityPrivacyTrackPanel* self;
	GtkToggleButton* _tmp0_;
#line 67 "../src/Views/TrackPanel.vala"
	self = _data7_->self;
#line 68 "../src/Views/TrackPanel.vala"
	_tmp0_ = _data7_->clear_data;
#line 68 "../src/Views/TrackPanel.vala"
	gtk_toggle_button_set_active (_tmp0_, FALSE);
#line 334 "TrackPanel.c"
}

static void
__security_privacy_track_panel___lambda21__gtk_popover_closed (GtkPopover* _sender,
                                                               gpointer self)
{
#line 67 "../src/Views/TrackPanel.vala"
	_security_privacy_track_panel___lambda21_ (self);
#line 343 "TrackPanel.c"
}

static void
_security_privacy_track_panel___lambda30_ (Block7Data* _data7_)
{
	SecurityPrivacyTrackPanel* self;
	gboolean privacy_mode = FALSE;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	IncludeTreeView* _tmp4_;
	ExcludeTreeView* _tmp5_;
	GtkFrame* _tmp6_;
	SecurityPrivacyBlacklist* _tmp7_;
	SecurityPrivacyBlacklist* _tmp8_;
#line 80 "../src/Views/TrackPanel.vala"
	self = _data7_->self;
#line 81 "../src/Views/TrackPanel.vala"
	_tmp0_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 81 "../src/Views/TrackPanel.vala"
	_tmp1_ = _tmp0_;
#line 81 "../src/Views/TrackPanel.vala"
	_tmp2_ = gtk_switch_get_active (_tmp1_);
#line 81 "../src/Views/TrackPanel.vala"
	_tmp3_ = _tmp2_;
#line 81 "../src/Views/TrackPanel.vala"
	privacy_mode = !_tmp3_;
#line 82 "../src/Views/TrackPanel.vala"
	_tmp4_ = _data7_->include_treeview;
#line 82 "../src/Views/TrackPanel.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, !privacy_mode);
#line 83 "../src/Views/TrackPanel.vala"
	_tmp5_ = _data7_->exclude_treeview;
#line 83 "../src/Views/TrackPanel.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, !privacy_mode);
#line 84 "../src/Views/TrackPanel.vala"
	_tmp6_ = _data7_->description_frame;
#line 84 "../src/Views/TrackPanel.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, privacy_mode);
#line 86 "../src/Views/TrackPanel.vala"
	_tmp7_ = security_privacy_track_panel_get_blacklist ();
#line 86 "../src/Views/TrackPanel.vala"
	_tmp8_ = _tmp7_;
#line 86 "../src/Views/TrackPanel.vala"
	if (privacy_mode != security_privacy_blacklist_get_incognito (_tmp8_)) {
#line 390 "TrackPanel.c"
		SecurityPrivacyBlacklist* _tmp9_;
		SecurityPrivacyBlacklist* _tmp10_;
		GSettings* privacy_settings = NULL;
		GSettings* _tmp11_;
		GSettings* _tmp12_;
		GSettings* _tmp13_;
#line 87 "../src/Views/TrackPanel.vala"
		_tmp9_ = security_privacy_track_panel_get_blacklist ();
#line 87 "../src/Views/TrackPanel.vala"
		_tmp10_ = _tmp9_;
#line 87 "../src/Views/TrackPanel.vala"
		security_privacy_blacklist_set_incognito (_tmp10_, privacy_mode);
#line 89 "../src/Views/TrackPanel.vala"
		_tmp11_ = g_settings_new ("org.gnome.desktop.privacy");
#line 89 "../src/Views/TrackPanel.vala"
		privacy_settings = _tmp11_;
#line 90 "../src/Views/TrackPanel.vala"
		_tmp12_ = privacy_settings;
#line 90 "../src/Views/TrackPanel.vala"
		g_settings_set_boolean (_tmp12_, "remember-recent-files", !privacy_mode);
#line 91 "../src/Views/TrackPanel.vala"
		_tmp13_ = privacy_settings;
#line 91 "../src/Views/TrackPanel.vala"
		g_settings_set_boolean (_tmp13_, "remember-app-usage", !privacy_mode);
#line 86 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (privacy_settings);
#line 417 "TrackPanel.c"
	}
#line 94 "../src/Views/TrackPanel.vala"
	security_privacy_track_panel_update_status_switch (self);
#line 421 "TrackPanel.c"
}

static void
__security_privacy_track_panel___lambda30__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
#line 80 "../src/Views/TrackPanel.vala"
	_security_privacy_track_panel___lambda30_ (self);
#line 431 "TrackPanel.c"
}

static GObject *
security_privacy_track_panel_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SecurityPrivacyTrackPanel * self;
	Block7Data* _data7_;
	gchar* description = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GraniteWidgetsAlertView* alert = NULL;
	const gchar* _tmp6_;
	GraniteWidgetsAlertView* _tmp7_;
	GraniteWidgetsAlertView* _tmp8_;
	GtkFrame* _tmp9_;
	GtkFrame* _tmp10_;
	GtkFrame* _tmp11_;
	GraniteWidgetsAlertView* _tmp12_;
	GtkSwitch* _tmp13_;
	GtkSwitch* _tmp14_;
	GtkToggleButton* _tmp15_;
	GtkToggleButton* _tmp16_;
	GtkToggleButton* _tmp17_;
	SecurityPrivacyWidgetsClearUsagePopover* _tmp18_;
	SecurityPrivacyWidgetsClearUsagePopover* _tmp19_;
	IncludeTreeView* _tmp20_;
	ExcludeTreeView* _tmp21_;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkFrame* _tmp24_;
	GtkGrid* _tmp25_;
	GtkGrid* _tmp26_;
	IncludeTreeView* _tmp27_;
	GtkGrid* _tmp28_;
	GtkGrid* _tmp29_;
	ExcludeTreeView* _tmp30_;
	GtkButtonBox* _tmp31_;
	GtkButtonBox* _tmp32_;
	GtkToggleButton* _tmp33_;
	GtkSwitch* _tmp34_;
	GtkSwitch* _tmp35_;
	GtkSwitch* _tmp36_;
	GtkSwitch* _tmp37_;
	SecurityPrivacyBlacklist* _tmp38_;
	SecurityPrivacyBlacklist* _tmp39_;
#line 41 "../src/Views/TrackPanel.vala"
	parent_class = G_OBJECT_CLASS (security_privacy_track_panel_parent_class);
#line 41 "../src/Views/TrackPanel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 41 "../src/Views/TrackPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_TRACK_PANEL, SecurityPrivacyTrackPanel);
#line 41 "../src/Views/TrackPanel.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 41 "../src/Views/TrackPanel.vala"
	_data7_->_ref_count_ = 1;
#line 41 "../src/Views/TrackPanel.vala"
	_data7_->self = g_object_ref (self);
#line 42 "../src/Views/TrackPanel.vala"
	_tmp0_ = security_privacy_track_panel_get_operating_system_name ();
#line 42 "../src/Views/TrackPanel.vala"
	_tmp1_ = _tmp0_;
#line 42 "../src/Views/TrackPanel.vala"
	_tmp2_ = g_strdup_printf (_ ("%s won't retain any further usage data."), _tmp1_);
#line 42 "../src/Views/TrackPanel.vala"
	_tmp3_ = _tmp2_;
#line 42 "../src/Views/TrackPanel.vala"
	_tmp4_ = g_strdup_printf ("%s %s\n\n%s", _tmp3_, _ ("The additional functionality that this data provides will be affected."), _ ("This may not prevent apps from recording their own usage data, such as" \
" browser history."));
#line 42 "../src/Views/TrackPanel.vala"
	_tmp5_ = _tmp4_;
#line 42 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp3_);
#line 42 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp1_);
#line 42 "../src/Views/TrackPanel.vala"
	description = _tmp5_;
#line 48 "../src/Views/TrackPanel.vala"
	_tmp6_ = description;
#line 48 "../src/Views/TrackPanel.vala"
	_tmp7_ = granite_widgets_alert_view_new (_ ("History Is Disabled"), _tmp6_, "");
#line 48 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp7_);
#line 48 "../src/Views/TrackPanel.vala"
	alert = _tmp7_;
#line 49 "../src/Views/TrackPanel.vala"
	_tmp8_ = alert;
#line 49 "../src/Views/TrackPanel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp8_);
#line 51 "../src/Views/TrackPanel.vala"
	_tmp9_ = (GtkFrame*) gtk_frame_new (NULL);
#line 51 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp9_);
#line 51 "../src/Views/TrackPanel.vala"
	_data7_->description_frame = _tmp9_;
#line 52 "../src/Views/TrackPanel.vala"
	_tmp10_ = _data7_->description_frame;
#line 52 "../src/Views/TrackPanel.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp10_, TRUE);
#line 53 "../src/Views/TrackPanel.vala"
	_tmp11_ = _data7_->description_frame;
#line 53 "../src/Views/TrackPanel.vala"
	_tmp12_ = alert;
#line 53 "../src/Views/TrackPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp12_);
#line 55 "../src/Views/TrackPanel.vala"
	_tmp13_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 55 "../src/Views/TrackPanel.vala"
	_tmp14_ = _tmp13_;
#line 55 "../src/Views/TrackPanel.vala"
	gtk_switch_set_active (_tmp14_, TRUE);
#line 57 "../src/Views/TrackPanel.vala"
	_tmp15_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("Clear History…"));
#line 57 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp15_);
#line 57 "../src/Views/TrackPanel.vala"
	_data7_->clear_data = _tmp15_;
#line 58 "../src/Views/TrackPanel.vala"
	_tmp16_ = _data7_->clear_data;
#line 58 "../src/Views/TrackPanel.vala"
	g_signal_connect_data ((GObject*) _tmp16_, "notify::active", (GCallback) __security_privacy_track_panel___lambda20__g_object_notify, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 66 "../src/Views/TrackPanel.vala"
	_tmp17_ = _data7_->clear_data;
#line 66 "../src/Views/TrackPanel.vala"
	_tmp18_ = security_privacy_widgets_clear_usage_popover_new ((GtkWidget*) _tmp17_);
#line 66 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp18_);
#line 66 "../src/Views/TrackPanel.vala"
	_g_object_unref0 (self->priv->remove_popover);
#line 66 "../src/Views/TrackPanel.vala"
	self->priv->remove_popover = _tmp18_;
#line 67 "../src/Views/TrackPanel.vala"
	_tmp19_ = self->priv->remove_popover;
#line 67 "../src/Views/TrackPanel.vala"
	g_signal_connect_data ((GtkPopover*) _tmp19_, "closed", (GCallback) __security_privacy_track_panel___lambda21__gtk_popover_closed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 71 "../src/Views/TrackPanel.vala"
	_tmp20_ = include_tree_view_new ();
#line 71 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp20_);
#line 71 "../src/Views/TrackPanel.vala"
	_data7_->include_treeview = _tmp20_;
#line 72 "../src/Views/TrackPanel.vala"
	_tmp21_ = exclude_tree_view_new ();
#line 72 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp21_);
#line 72 "../src/Views/TrackPanel.vala"
	_data7_->exclude_treeview = _tmp21_;
#line 74 "../src/Views/TrackPanel.vala"
	_tmp22_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 74 "../src/Views/TrackPanel.vala"
	_tmp23_ = _tmp22_;
#line 74 "../src/Views/TrackPanel.vala"
	_tmp24_ = _data7_->description_frame;
#line 74 "../src/Views/TrackPanel.vala"
	gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp24_, 0, 1, 2, 1);
#line 75 "../src/Views/TrackPanel.vala"
	_tmp25_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 75 "../src/Views/TrackPanel.vala"
	_tmp26_ = _tmp25_;
#line 75 "../src/Views/TrackPanel.vala"
	_tmp27_ = _data7_->include_treeview;
#line 75 "../src/Views/TrackPanel.vala"
	gtk_grid_attach (_tmp26_, (GtkWidget*) _tmp27_, 0, 1, 1, 1);
#line 76 "../src/Views/TrackPanel.vala"
	_tmp28_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
#line 76 "../src/Views/TrackPanel.vala"
	_tmp29_ = _tmp28_;
#line 76 "../src/Views/TrackPanel.vala"
	_tmp30_ = _data7_->exclude_treeview;
#line 76 "../src/Views/TrackPanel.vala"
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 1, 1, 1, 1);
#line 78 "../src/Views/TrackPanel.vala"
	_tmp31_ = granite_simple_settings_page_get_action_area ((GraniteSimpleSettingsPage*) self);
#line 78 "../src/Views/TrackPanel.vala"
	_tmp32_ = _tmp31_;
#line 78 "../src/Views/TrackPanel.vala"
	_tmp33_ = _data7_->clear_data;
#line 78 "../src/Views/TrackPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
#line 80 "../src/Views/TrackPanel.vala"
	_tmp34_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 80 "../src/Views/TrackPanel.vala"
	_tmp35_ = _tmp34_;
#line 80 "../src/Views/TrackPanel.vala"
	g_signal_connect_data ((GObject*) _tmp35_, "notify::active", (GCallback) __security_privacy_track_panel___lambda30__g_object_notify, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 97 "../src/Views/TrackPanel.vala"
	_tmp36_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
#line 97 "../src/Views/TrackPanel.vala"
	_tmp37_ = _tmp36_;
#line 97 "../src/Views/TrackPanel.vala"
	_tmp38_ = security_privacy_track_panel_get_blacklist ();
#line 97 "../src/Views/TrackPanel.vala"
	_tmp39_ = _tmp38_;
#line 97 "../src/Views/TrackPanel.vala"
	gtk_switch_set_active (_tmp37_, !security_privacy_blacklist_get_incognito (_tmp39_));
#line 99 "../src/Views/TrackPanel.vala"
	security_privacy_track_panel_update_status_switch (self);
#line 41 "../src/Views/TrackPanel.vala"
	_g_object_unref0 (alert);
#line 41 "../src/Views/TrackPanel.vala"
	_g_free0 (description);
#line 41 "../src/Views/TrackPanel.vala"
	block7_data_unref (_data7_);
#line 41 "../src/Views/TrackPanel.vala"
	_data7_ = NULL;
#line 41 "../src/Views/TrackPanel.vala"
	return obj;
#line 645 "TrackPanel.c"
}

static void
security_privacy_track_panel_class_init (SecurityPrivacyTrackPanelClass * klass,
                                         gpointer klass_data)
{
	SecurityPrivacyBlacklist* _tmp0_;
	SecurityPrivacyBlacklist* _tmp1_;
#line 23 "../src/Views/TrackPanel.vala"
	security_privacy_track_panel_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Views/TrackPanel.vala"
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyTrackPanel_private_offset);
#line 23 "../src/Views/TrackPanel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_security_privacy_track_panel_get_property;
#line 23 "../src/Views/TrackPanel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_security_privacy_track_panel_set_property;
#line 23 "../src/Views/TrackPanel.vala"
	G_OBJECT_CLASS (klass)->constructor = security_privacy_track_panel_constructor;
#line 23 "../src/Views/TrackPanel.vala"
	G_OBJECT_CLASS (klass)->finalize = security_privacy_track_panel_finalize;
#line 38 "../src/Views/TrackPanel.vala"
	_tmp0_ = security_privacy_blacklist_new ();
#line 38 "../src/Views/TrackPanel.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/Views/TrackPanel.vala"
	security_privacy_track_panel_set_blacklist (_tmp1_);
#line 38 "../src/Views/TrackPanel.vala"
	_security_privacy_blacklist_unref0 (_tmp1_);
#line 674 "TrackPanel.c"
}

static void
security_privacy_track_panel_instance_init (SecurityPrivacyTrackPanel * self,
                                            gpointer klass)
{
#line 23 "../src/Views/TrackPanel.vala"
	self->priv = security_privacy_track_panel_get_instance_private (self);
#line 683 "TrackPanel.c"
}

static void
security_privacy_track_panel_finalize (GObject * obj)
{
	SecurityPrivacyTrackPanel * self;
#line 23 "../src/Views/TrackPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_TRACK_PANEL, SecurityPrivacyTrackPanel);
#line 26 "../src/Views/TrackPanel.vala"
	_g_object_unref0 (self->priv->remove_popover);
#line 23 "../src/Views/TrackPanel.vala"
	G_OBJECT_CLASS (security_privacy_track_panel_parent_class)->finalize (obj);
#line 696 "TrackPanel.c"
}

static GType
security_privacy_track_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyTrackPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_track_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyTrackPanel), 0, (GInstanceInitFunc) security_privacy_track_panel_instance_init, NULL };
	GType security_privacy_track_panel_type_id;
	security_privacy_track_panel_type_id = g_type_register_static (GRANITE_TYPE_SIMPLE_SETTINGS_PAGE, "SecurityPrivacyTrackPanel", &g_define_type_info, 0);
	SecurityPrivacyTrackPanel_private_offset = g_type_add_instance_private (security_privacy_track_panel_type_id, sizeof (SecurityPrivacyTrackPanelPrivate));
	return security_privacy_track_panel_type_id;
}

GType
security_privacy_track_panel_get_type (void)
{
	static volatile gsize security_privacy_track_panel_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_track_panel_type_id__once)) {
		GType security_privacy_track_panel_type_id;
		security_privacy_track_panel_type_id = security_privacy_track_panel_get_type_once ();
		g_once_init_leave (&security_privacy_track_panel_type_id__once, security_privacy_track_panel_type_id);
	}
	return security_privacy_track_panel_type_id__once;
}

static void
_vala_security_privacy_track_panel_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	SecurityPrivacyTrackPanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SECURITY_PRIVACY_TYPE_TRACK_PANEL, SecurityPrivacyTrackPanel);
#line 23 "../src/Views/TrackPanel.vala"
	switch (property_id) {
#line 731 "TrackPanel.c"
		default:
#line 23 "../src/Views/TrackPanel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Views/TrackPanel.vala"
		break;
#line 737 "TrackPanel.c"
	}
}

static void
_vala_security_privacy_track_panel_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	SecurityPrivacyTrackPanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SECURITY_PRIVACY_TYPE_TRACK_PANEL, SecurityPrivacyTrackPanel);
#line 23 "../src/Views/TrackPanel.vala"
	switch (property_id) {
#line 751 "TrackPanel.c"
		default:
#line 23 "../src/Views/TrackPanel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Views/TrackPanel.vala"
		break;
#line 757 "TrackPanel.c"
	}
}

