/* ServiceItem.c generated by valac 0.56.14, the Vala compiler
 * generated from ServiceItem.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (http://launchpad.net/switchboard-plug-security-privacy)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "security-privacy.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

enum  {
	SERVICE_ITEM_0_PROPERTY,
	SERVICE_ITEM_STATUS_PROPERTY,
	SERVICE_ITEM_ICON_NAME_PROPERTY,
	SERVICE_ITEM_LABEL_PROPERTY,
	SERVICE_ITEM_TITLE_PROPERTY,
	SERVICE_ITEM_NUM_PROPERTIES
};
static GParamSpec* service_item_properties[SERVICE_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ServiceItemPrivate {
	GtkImage* status_icon;
	GtkLabel* status_label;
	gchar* _icon_name;
	gchar* _label;
	gchar* _title;
};

static gint ServiceItem_private_offset;
static gpointer service_item_parent_class = NULL;

static GObject * service_item_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void service_item_finalize (GObject * obj);
static GType service_item_get_type_once (void);
static void _vala_service_item_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_service_item_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
service_item_get_instance_private (ServiceItem* self)
{
	return G_STRUCT_MEMBER_P (self, ServiceItem_private_offset);
}

static GType
service_item_status_get_type_once (void)
{
	static const GEnumValue values[] = {{SERVICE_ITEM_STATUS_ENABLED, "SERVICE_ITEM_STATUS_ENABLED", "enabled"}, {SERVICE_ITEM_STATUS_DISABLED, "SERVICE_ITEM_STATUS_DISABLED", "disabled"}, {SERVICE_ITEM_STATUS_PARTIAL, "SERVICE_ITEM_STATUS_PARTIAL", "partial"}, {0, NULL, NULL}};
	GType service_item_status_type_id;
	service_item_status_type_id = g_enum_register_static ("ServiceItemStatus", values);
	return service_item_status_type_id;
}

GType
service_item_status_get_type (void)
{
	static volatile gsize service_item_status_type_id__once = 0;
	if (g_once_init_enter (&service_item_status_type_id__once)) {
		GType service_item_status_type_id;
		service_item_status_type_id = service_item_status_get_type_once ();
		g_once_init_leave (&service_item_status_type_id__once, service_item_status_type_id);
	}
	return service_item_status_type_id__once;
}

ServiceItem*
service_item_construct (GType object_type,
                        const gchar* icon_name,
                        const gchar* title,
                        const gchar* label)
{
	ServiceItem * self = NULL;
#line 57 "../src/Widgets/ServiceItem.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 57 "../src/Widgets/ServiceItem.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 57 "../src/Widgets/ServiceItem.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 58 "../src/Widgets/ServiceItem.vala"
	self = (ServiceItem*) g_object_new (object_type, "icon-name", icon_name, "label", label, "title", title, NULL);
#line 57 "../src/Widgets/ServiceItem.vala"
	return self;
#line 117 "ServiceItem.c"
}

ServiceItem*
service_item_new (const gchar* icon_name,
                  const gchar* title,
                  const gchar* label)
{
#line 57 "../src/Widgets/ServiceItem.vala"
	return service_item_construct (TYPE_SERVICE_ITEM, icon_name, title, label);
#line 127 "ServiceItem.c"
}

void
service_item_set_status (ServiceItem* self,
                         ServiceItemStatus value)
{
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
#line 29 "../src/Widgets/ServiceItem.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Widgets/ServiceItem.vala"
	switch (value) {
#line 30 "../src/Widgets/ServiceItem.vala"
		case SERVICE_ITEM_STATUS_ENABLED:
#line 150 "ServiceItem.c"
		{
			GtkImage* _tmp0_;
			GtkLabel* _tmp1_;
#line 32 "../src/Widgets/ServiceItem.vala"
			_tmp0_ = self->priv->status_icon;
#line 32 "../src/Widgets/ServiceItem.vala"
			g_object_set (_tmp0_, "icon-name", "user-available", NULL);
#line 33 "../src/Widgets/ServiceItem.vala"
			_tmp1_ = self->priv->status_label;
#line 33 "../src/Widgets/ServiceItem.vala"
			gtk_label_set_label (_tmp1_, _ ("Enabled"));
#line 34 "../src/Widgets/ServiceItem.vala"
			break;
#line 164 "ServiceItem.c"
		}
#line 30 "../src/Widgets/ServiceItem.vala"
		case SERVICE_ITEM_STATUS_DISABLED:
#line 168 "ServiceItem.c"
		{
			GtkImage* _tmp2_;
			GtkLabel* _tmp3_;
#line 36 "../src/Widgets/ServiceItem.vala"
			_tmp2_ = self->priv->status_icon;
#line 36 "../src/Widgets/ServiceItem.vala"
			g_object_set (_tmp2_, "icon-name", "user-offline", NULL);
#line 37 "../src/Widgets/ServiceItem.vala"
			_tmp3_ = self->priv->status_label;
#line 37 "../src/Widgets/ServiceItem.vala"
			gtk_label_set_label (_tmp3_, _ ("Disabled"));
#line 38 "../src/Widgets/ServiceItem.vala"
			break;
#line 182 "ServiceItem.c"
		}
#line 30 "../src/Widgets/ServiceItem.vala"
		case SERVICE_ITEM_STATUS_PARTIAL:
#line 186 "ServiceItem.c"
		{
			GtkImage* _tmp4_;
			GtkLabel* _tmp5_;
#line 40 "../src/Widgets/ServiceItem.vala"
			_tmp4_ = self->priv->status_icon;
#line 40 "../src/Widgets/ServiceItem.vala"
			g_object_set (_tmp4_, "icon-name", "user-away", NULL);
#line 41 "../src/Widgets/ServiceItem.vala"
			_tmp5_ = self->priv->status_label;
#line 41 "../src/Widgets/ServiceItem.vala"
			gtk_label_set_label (_tmp5_, _ ("Partially Enabled"));
#line 42 "../src/Widgets/ServiceItem.vala"
			break;
#line 200 "ServiceItem.c"
		}
		default:
#line 30 "../src/Widgets/ServiceItem.vala"
		break;
#line 205 "ServiceItem.c"
	}
#line 44 "../src/Widgets/ServiceItem.vala"
	_tmp6_ = self->priv->status_label;
#line 44 "../src/Widgets/ServiceItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp6_, FALSE);
#line 45 "../src/Widgets/ServiceItem.vala"
	_tmp7_ = self->priv->status_label;
#line 45 "../src/Widgets/ServiceItem.vala"
	gtk_widget_show ((GtkWidget*) _tmp7_);
#line 46 "../src/Widgets/ServiceItem.vala"
	_tmp8_ = self->priv->status_label;
#line 46 "../src/Widgets/ServiceItem.vala"
	_tmp9_ = self->priv->status_label;
#line 46 "../src/Widgets/ServiceItem.vala"
	_tmp10_ = gtk_label_get_label (_tmp9_);
#line 46 "../src/Widgets/ServiceItem.vala"
	_tmp11_ = _tmp10_;
#line 46 "../src/Widgets/ServiceItem.vala"
	_tmp12_ = g_strconcat ("<span font_size='small'>", _tmp11_, NULL);
#line 46 "../src/Widgets/ServiceItem.vala"
	_tmp13_ = _tmp12_;
#line 46 "../src/Widgets/ServiceItem.vala"
	_tmp14_ = g_strconcat (_tmp13_, "</span>", NULL);
#line 46 "../src/Widgets/ServiceItem.vala"
	_tmp15_ = _tmp14_;
#line 46 "../src/Widgets/ServiceItem.vala"
	gtk_label_set_label (_tmp8_, _tmp15_);
#line 46 "../src/Widgets/ServiceItem.vala"
	_g_free0 (_tmp15_);
#line 46 "../src/Widgets/ServiceItem.vala"
	_g_free0 (_tmp13_);
#line 29 "../src/Widgets/ServiceItem.vala"
	g_object_notify_by_pspec ((GObject *) self, service_item_properties[SERVICE_ITEM_STATUS_PROPERTY]);
#line 239 "ServiceItem.c"
}

const gchar*
service_item_get_icon_name (ServiceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 53 "../src/Widgets/ServiceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/Widgets/ServiceItem.vala"
	_tmp0_ = self->priv->_icon_name;
#line 53 "../src/Widgets/ServiceItem.vala"
	result = _tmp0_;
#line 53 "../src/Widgets/ServiceItem.vala"
	return result;
#line 255 "ServiceItem.c"
}

static void
service_item_set_icon_name (ServiceItem* self,
                            const gchar* value)
{
	gchar* old_value;
#line 53 "../src/Widgets/ServiceItem.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/Widgets/ServiceItem.vala"
	old_value = service_item_get_icon_name (self);
#line 53 "../src/Widgets/ServiceItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 269 "ServiceItem.c"
		gchar* _tmp0_;
#line 53 "../src/Widgets/ServiceItem.vala"
		_tmp0_ = g_strdup (value);
#line 53 "../src/Widgets/ServiceItem.vala"
		_g_free0 (self->priv->_icon_name);
#line 53 "../src/Widgets/ServiceItem.vala"
		self->priv->_icon_name = _tmp0_;
#line 53 "../src/Widgets/ServiceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, service_item_properties[SERVICE_ITEM_ICON_NAME_PROPERTY]);
#line 279 "ServiceItem.c"
	}
}

const gchar*
service_item_get_label (ServiceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../src/Widgets/ServiceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/Widgets/ServiceItem.vala"
	_tmp0_ = self->priv->_label;
#line 54 "../src/Widgets/ServiceItem.vala"
	result = _tmp0_;
#line 54 "../src/Widgets/ServiceItem.vala"
	return result;
#line 296 "ServiceItem.c"
}

static void
service_item_set_label (ServiceItem* self,
                        const gchar* value)
{
	gchar* old_value;
#line 54 "../src/Widgets/ServiceItem.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/Widgets/ServiceItem.vala"
	old_value = service_item_get_label (self);
#line 54 "../src/Widgets/ServiceItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 310 "ServiceItem.c"
		gchar* _tmp0_;
#line 54 "../src/Widgets/ServiceItem.vala"
		_tmp0_ = g_strdup (value);
#line 54 "../src/Widgets/ServiceItem.vala"
		_g_free0 (self->priv->_label);
#line 54 "../src/Widgets/ServiceItem.vala"
		self->priv->_label = _tmp0_;
#line 54 "../src/Widgets/ServiceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, service_item_properties[SERVICE_ITEM_LABEL_PROPERTY]);
#line 320 "ServiceItem.c"
	}
}

const gchar*
service_item_get_title (ServiceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 55 "../src/Widgets/ServiceItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/Widgets/ServiceItem.vala"
	_tmp0_ = self->priv->_title;
#line 55 "../src/Widgets/ServiceItem.vala"
	result = _tmp0_;
#line 55 "../src/Widgets/ServiceItem.vala"
	return result;
#line 337 "ServiceItem.c"
}

static void
service_item_set_title (ServiceItem* self,
                        const gchar* value)
{
	gchar* old_value;
#line 55 "../src/Widgets/ServiceItem.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Widgets/ServiceItem.vala"
	old_value = service_item_get_title (self);
#line 55 "../src/Widgets/ServiceItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 351 "ServiceItem.c"
		gchar* _tmp0_;
#line 55 "../src/Widgets/ServiceItem.vala"
		_tmp0_ = g_strdup (value);
#line 55 "../src/Widgets/ServiceItem.vala"
		_g_free0 (self->priv->_title);
#line 55 "../src/Widgets/ServiceItem.vala"
		self->priv->_title = _tmp0_;
#line 55 "../src/Widgets/ServiceItem.vala"
		g_object_notify_by_pspec ((GObject *) self, service_item_properties[SERVICE_ITEM_TITLE_PROPERTY]);
#line 361 "ServiceItem.c"
	}
}

static GObject *
service_item_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ServiceItem * self;
	GtkImage* icon = NULL;
	const gchar* _tmp0_;
	GtkImage* _tmp1_;
	GtkLabel* title_label = NULL;
	const gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp16_;
	GtkOverlay* _tmp17_;
	GtkOverlay* _tmp18_;
	GtkImage* _tmp19_;
	GtkOverlay* _tmp20_;
	GtkImage* _tmp21_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	GtkOverlay* _tmp26_;
	GtkGrid* _tmp27_;
	GtkLabel* _tmp28_;
	GtkGrid* _tmp29_;
	GtkLabel* _tmp30_;
	GtkGrid* _tmp31_;
#line 63 "../src/Widgets/ServiceItem.vala"
	parent_class = G_OBJECT_CLASS (service_item_parent_class);
#line 63 "../src/Widgets/ServiceItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 63 "../src/Widgets/ServiceItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERVICE_ITEM, ServiceItem);
#line 64 "../src/Widgets/ServiceItem.vala"
	_tmp0_ = self->priv->_icon_name;
#line 64 "../src/Widgets/ServiceItem.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DND);
#line 64 "../src/Widgets/ServiceItem.vala"
	g_object_ref_sink (_tmp1_);
#line 64 "../src/Widgets/ServiceItem.vala"
	icon = _tmp1_;
#line 66 "../src/Widgets/ServiceItem.vala"
	_tmp2_ = self->priv->_label;
#line 66 "../src/Widgets/ServiceItem.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
#line 66 "../src/Widgets/ServiceItem.vala"
	g_object_ref_sink (_tmp3_);
#line 66 "../src/Widgets/ServiceItem.vala"
	title_label = _tmp3_;
#line 67 "../src/Widgets/ServiceItem.vala"
	_tmp4_ = title_label;
#line 67 "../src/Widgets/ServiceItem.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 67 "../src/Widgets/ServiceItem.vala"
	gtk_style_context_add_class (_tmp5_, "h3");
#line 68 "../src/Widgets/ServiceItem.vala"
	_tmp6_ = title_label;
#line 68 "../src/Widgets/ServiceItem.vala"
	gtk_label_set_ellipsize (_tmp6_, PANGO_ELLIPSIZE_END);
#line 69 "../src/Widgets/ServiceItem.vala"
	_tmp7_ = title_label;
#line 69 "../src/Widgets/ServiceItem.vala"
	gtk_label_set_xalign (_tmp7_, (gfloat) 0);
#line 71 "../src/Widgets/ServiceItem.vala"
	_tmp8_ = (GtkImage*) gtk_image_new ();
#line 71 "../src/Widgets/ServiceItem.vala"
	g_object_ref_sink (_tmp8_);
#line 71 "../src/Widgets/ServiceItem.vala"
	_g_object_unref0 (self->priv->status_icon);
#line 71 "../src/Widgets/ServiceItem.vala"
	self->priv->status_icon = _tmp8_;
#line 72 "../src/Widgets/ServiceItem.vala"
	_tmp9_ = self->priv->status_icon;
#line 72 "../src/Widgets/ServiceItem.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_END);
#line 73 "../src/Widgets/ServiceItem.vala"
	_tmp10_ = self->priv->status_icon;
#line 73 "../src/Widgets/ServiceItem.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_END);
#line 75 "../src/Widgets/ServiceItem.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new (NULL);
#line 75 "../src/Widgets/ServiceItem.vala"
	g_object_ref_sink (_tmp11_);
#line 75 "../src/Widgets/ServiceItem.vala"
	_g_object_unref0 (self->priv->status_label);
#line 75 "../src/Widgets/ServiceItem.vala"
	self->priv->status_label = _tmp11_;
#line 76 "../src/Widgets/ServiceItem.vala"
	_tmp12_ = self->priv->status_label;
#line 76 "../src/Widgets/ServiceItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp12_, TRUE);
#line 77 "../src/Widgets/ServiceItem.vala"
	_tmp13_ = self->priv->status_label;
#line 77 "../src/Widgets/ServiceItem.vala"
	gtk_label_set_use_markup (_tmp13_, TRUE);
#line 78 "../src/Widgets/ServiceItem.vala"
	_tmp14_ = self->priv->status_label;
#line 78 "../src/Widgets/ServiceItem.vala"
	gtk_label_set_ellipsize (_tmp14_, PANGO_ELLIPSIZE_END);
#line 79 "../src/Widgets/ServiceItem.vala"
	_tmp15_ = self->priv->status_label;
#line 79 "../src/Widgets/ServiceItem.vala"
	gtk_label_set_xalign (_tmp15_, (gfloat) 0);
#line 81 "../src/Widgets/ServiceItem.vala"
	_tmp16_ = (GtkOverlay*) gtk_overlay_new ();
#line 81 "../src/Widgets/ServiceItem.vala"
	g_object_ref_sink (_tmp16_);
#line 81 "../src/Widgets/ServiceItem.vala"
	overlay = _tmp16_;
#line 82 "../src/Widgets/ServiceItem.vala"
	_tmp17_ = overlay;
#line 82 "../src/Widgets/ServiceItem.vala"
	g_object_set ((GtkWidget*) _tmp17_, "width-request", 38, NULL);
#line 83 "../src/Widgets/ServiceItem.vala"
	_tmp18_ = overlay;
#line 83 "../src/Widgets/ServiceItem.vala"
	_tmp19_ = icon;
#line 83 "../src/Widgets/ServiceItem.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 84 "../src/Widgets/ServiceItem.vala"
	_tmp20_ = overlay;
#line 84 "../src/Widgets/ServiceItem.vala"
	_tmp21_ = self->priv->status_icon;
#line 84 "../src/Widgets/ServiceItem.vala"
	gtk_overlay_add_overlay (_tmp20_, (GtkWidget*) _tmp21_);
#line 86 "../src/Widgets/ServiceItem.vala"
	_tmp22_ = (GtkGrid*) gtk_grid_new ();
#line 86 "../src/Widgets/ServiceItem.vala"
	g_object_ref_sink (_tmp22_);
#line 86 "../src/Widgets/ServiceItem.vala"
	grid = _tmp22_;
#line 87 "../src/Widgets/ServiceItem.vala"
	_tmp23_ = grid;
#line 87 "../src/Widgets/ServiceItem.vala"
	g_object_set ((GtkWidget*) _tmp23_, "margin", 6, NULL);
#line 88 "../src/Widgets/ServiceItem.vala"
	_tmp24_ = grid;
#line 88 "../src/Widgets/ServiceItem.vala"
	gtk_grid_set_column_spacing (_tmp24_, 6);
#line 89 "../src/Widgets/ServiceItem.vala"
	_tmp25_ = grid;
#line 89 "../src/Widgets/ServiceItem.vala"
	_tmp26_ = overlay;
#line 89 "../src/Widgets/ServiceItem.vala"
	gtk_grid_attach (_tmp25_, (GtkWidget*) _tmp26_, 0, 0, 1, 2);
#line 90 "../src/Widgets/ServiceItem.vala"
	_tmp27_ = grid;
#line 90 "../src/Widgets/ServiceItem.vala"
	_tmp28_ = title_label;
#line 90 "../src/Widgets/ServiceItem.vala"
	gtk_grid_attach (_tmp27_, (GtkWidget*) _tmp28_, 1, 0, 1, 1);
#line 91 "../src/Widgets/ServiceItem.vala"
	_tmp29_ = grid;
#line 91 "../src/Widgets/ServiceItem.vala"
	_tmp30_ = self->priv->status_label;
#line 91 "../src/Widgets/ServiceItem.vala"
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 1, 1, 1, 1);
#line 93 "../src/Widgets/ServiceItem.vala"
	_tmp31_ = grid;
#line 93 "../src/Widgets/ServiceItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp31_);
#line 63 "../src/Widgets/ServiceItem.vala"
	_g_object_unref0 (grid);
#line 63 "../src/Widgets/ServiceItem.vala"
	_g_object_unref0 (overlay);
#line 63 "../src/Widgets/ServiceItem.vala"
	_g_object_unref0 (title_label);
#line 63 "../src/Widgets/ServiceItem.vala"
	_g_object_unref0 (icon);
#line 63 "../src/Widgets/ServiceItem.vala"
	return obj;
#line 553 "ServiceItem.c"
}

static void
service_item_class_init (ServiceItemClass * klass,
                         gpointer klass_data)
{
#line 21 "../src/Widgets/ServiceItem.vala"
	service_item_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/ServiceItem.vala"
	g_type_class_adjust_private_offset (klass, &ServiceItem_private_offset);
#line 21 "../src/Widgets/ServiceItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_service_item_get_property;
#line 21 "../src/Widgets/ServiceItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_service_item_set_property;
#line 21 "../src/Widgets/ServiceItem.vala"
	G_OBJECT_CLASS (klass)->constructor = service_item_constructor;
#line 21 "../src/Widgets/ServiceItem.vala"
	G_OBJECT_CLASS (klass)->finalize = service_item_finalize;
#line 21 "../src/Widgets/ServiceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICE_ITEM_STATUS_PROPERTY, service_item_properties[SERVICE_ITEM_STATUS_PROPERTY] = g_param_spec_enum ("status", "status", "status", SERVICE_ITEM_TYPE_STATUS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/ServiceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICE_ITEM_ICON_NAME_PROPERTY, service_item_properties[SERVICE_ITEM_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Widgets/ServiceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICE_ITEM_LABEL_PROPERTY, service_item_properties[SERVICE_ITEM_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Widgets/ServiceItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICE_ITEM_TITLE_PROPERTY, service_item_properties[SERVICE_ITEM_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 580 "ServiceItem.c"
}

static void
service_item_instance_init (ServiceItem * self,
                            gpointer klass)
{
#line 21 "../src/Widgets/ServiceItem.vala"
	self->priv = service_item_get_instance_private (self);
#line 589 "ServiceItem.c"
}

static void
service_item_finalize (GObject * obj)
{
	ServiceItem * self;
#line 21 "../src/Widgets/ServiceItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERVICE_ITEM, ServiceItem);
#line 50 "../src/Widgets/ServiceItem.vala"
	_g_object_unref0 (self->priv->status_icon);
#line 51 "../src/Widgets/ServiceItem.vala"
	_g_object_unref0 (self->priv->status_label);
#line 53 "../src/Widgets/ServiceItem.vala"
	_g_free0 (self->priv->_icon_name);
#line 54 "../src/Widgets/ServiceItem.vala"
	_g_free0 (self->priv->_label);
#line 55 "../src/Widgets/ServiceItem.vala"
	_g_free0 (self->priv->_title);
#line 21 "../src/Widgets/ServiceItem.vala"
	G_OBJECT_CLASS (service_item_parent_class)->finalize (obj);
#line 610 "ServiceItem.c"
}

static GType
service_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServiceItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) service_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServiceItem), 0, (GInstanceInitFunc) service_item_instance_init, NULL };
	GType service_item_type_id;
	service_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "ServiceItem", &g_define_type_info, 0);
	ServiceItem_private_offset = g_type_add_instance_private (service_item_type_id, sizeof (ServiceItemPrivate));
	return service_item_type_id;
}

GType
service_item_get_type (void)
{
	static volatile gsize service_item_type_id__once = 0;
	if (g_once_init_enter (&service_item_type_id__once)) {
		GType service_item_type_id;
		service_item_type_id = service_item_get_type_once ();
		g_once_init_leave (&service_item_type_id__once, service_item_type_id);
	}
	return service_item_type_id__once;
}

static void
_vala_service_item_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ServiceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERVICE_ITEM, ServiceItem);
#line 21 "../src/Widgets/ServiceItem.vala"
	switch (property_id) {
#line 21 "../src/Widgets/ServiceItem.vala"
		case SERVICE_ITEM_ICON_NAME_PROPERTY:
#line 21 "../src/Widgets/ServiceItem.vala"
		g_value_set_string (value, service_item_get_icon_name (self));
#line 21 "../src/Widgets/ServiceItem.vala"
		break;
#line 21 "../src/Widgets/ServiceItem.vala"
		case SERVICE_ITEM_LABEL_PROPERTY:
#line 21 "../src/Widgets/ServiceItem.vala"
		g_value_set_string (value, service_item_get_label (self));
#line 21 "../src/Widgets/ServiceItem.vala"
		break;
#line 21 "../src/Widgets/ServiceItem.vala"
		case SERVICE_ITEM_TITLE_PROPERTY:
#line 21 "../src/Widgets/ServiceItem.vala"
		g_value_set_string (value, service_item_get_title (self));
#line 21 "../src/Widgets/ServiceItem.vala"
		break;
#line 663 "ServiceItem.c"
		default:
#line 21 "../src/Widgets/ServiceItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/ServiceItem.vala"
		break;
#line 669 "ServiceItem.c"
	}
}

static void
_vala_service_item_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ServiceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERVICE_ITEM, ServiceItem);
#line 21 "../src/Widgets/ServiceItem.vala"
	switch (property_id) {
#line 21 "../src/Widgets/ServiceItem.vala"
		case SERVICE_ITEM_STATUS_PROPERTY:
#line 21 "../src/Widgets/ServiceItem.vala"
		service_item_set_status (self, g_value_get_enum (value));
#line 21 "../src/Widgets/ServiceItem.vala"
		break;
#line 21 "../src/Widgets/ServiceItem.vala"
		case SERVICE_ITEM_ICON_NAME_PROPERTY:
#line 21 "../src/Widgets/ServiceItem.vala"
		service_item_set_icon_name (self, g_value_get_string (value));
#line 21 "../src/Widgets/ServiceItem.vala"
		break;
#line 21 "../src/Widgets/ServiceItem.vala"
		case SERVICE_ITEM_LABEL_PROPERTY:
#line 21 "../src/Widgets/ServiceItem.vala"
		service_item_set_label (self, g_value_get_string (value));
#line 21 "../src/Widgets/ServiceItem.vala"
		break;
#line 21 "../src/Widgets/ServiceItem.vala"
		case SERVICE_ITEM_TITLE_PROPERTY:
#line 21 "../src/Widgets/ServiceItem.vala"
		service_item_set_title (self, g_value_get_string (value));
#line 21 "../src/Widgets/ServiceItem.vala"
		break;
#line 707 "ServiceItem.c"
		default:
#line 21 "../src/Widgets/ServiceItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/ServiceItem.vala"
		break;
#line 713 "ServiceItem.c"
	}
}

