/* ServiceList.c generated by valac 0.56.14, the Vala compiler
 * generated from ServiceList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (http://launchpad.net/switchboard-plug-security-privacy)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "security-privacy.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

enum  {
	SERVICE_LIST_0_PROPERTY,
	SERVICE_LIST_NUM_PROPERTIES
};
static GParamSpec* service_list_properties[SERVICE_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block12Data Block12Data;

struct _ServiceListPrivate {
	ServiceItem* housekeeping_item;
	GeeHashMap* services;
};

struct _Block12Data {
	int _ref_count_;
	ServiceList* self;
	ServiceItem* privacy_item;
	ServiceItem* firewall_item;
	ServiceItem* location_item;
};

static gint ServiceList_private_offset;
static gpointer service_list_parent_class = NULL;

static void service_list_update_service_status (ServiceList* self,
                                         ServiceItem* service_item,
                                         gboolean service_status);
static void service_list_update_housekeeping_status (ServiceList* self);
static GObject * service_list_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void _service_list___lambda31_ (Block12Data* _data12_);
static void __service_list___lambda31__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static void _service_list___lambda32_ (ServiceList* self);
static void __service_list___lambda32__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static void _service_list___lambda33_ (Block12Data* _data12_);
static void __service_list___lambda33__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static void _service_list___lambda34_ (Block12Data* _data12_);
static void __service_list___lambda34__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static void service_list_finalize (GObject * obj);
static GType service_list_get_type_once (void);

static inline gpointer
service_list_get_instance_private (ServiceList* self)
{
	return G_STRUCT_MEMBER_P (self, ServiceList_private_offset);
}

ServiceList*
service_list_construct (GType object_type)
{
	ServiceList * self = NULL;
#line 26 "../src/Widgets/ServiceList.vala"
	self = (ServiceList*) g_object_new (object_type, "activate-on-single-click", TRUE, "selection-mode", GTK_SELECTION_SINGLE, NULL);
#line 25 "../src/Widgets/ServiceList.vala"
	return self;
#line 101 "ServiceList.c"
}

ServiceList*
service_list_new (void)
{
#line 25 "../src/Widgets/ServiceList.vala"
	return service_list_construct (TYPE_SERVICE_LIST);
#line 109 "ServiceList.c"
}

static void
service_list_update_service_status (ServiceList* self,
                                    ServiceItem* service_item,
                                    gboolean service_status)
{
#line 70 "../src/Widgets/ServiceList.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/Widgets/ServiceList.vala"
	g_return_if_fail (service_item != NULL);
#line 71 "../src/Widgets/ServiceList.vala"
	if (service_status) {
#line 72 "../src/Widgets/ServiceList.vala"
		service_item_set_status (service_item, SERVICE_ITEM_STATUS_ENABLED);
#line 125 "ServiceList.c"
	} else {
#line 74 "../src/Widgets/ServiceList.vala"
		service_item_set_status (service_item, SERVICE_ITEM_STATUS_DISABLED);
#line 129 "ServiceList.c"
	}
}

static void
service_list_update_housekeeping_status (ServiceList* self)
{
	SecurityPrivacyHouseKeepingPanel* _tmp0_;
	GraniteSettingsPageStatusType _tmp1_;
	GraniteSettingsPageStatusType _tmp2_;
#line 78 "../src/Widgets/ServiceList.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/Widgets/ServiceList.vala"
	_tmp0_ = security_privacy_housekeeping;
#line 79 "../src/Widgets/ServiceList.vala"
	_tmp1_ = granite_settings_page_get_status_type ((GraniteSettingsPage*) _tmp0_);
#line 79 "../src/Widgets/ServiceList.vala"
	_tmp2_ = _tmp1_;
#line 79 "../src/Widgets/ServiceList.vala"
	if (_tmp2_ == GRANITE_SETTINGS_PAGE_STATUS_TYPE_SUCCESS) {
#line 149 "ServiceList.c"
		ServiceItem* _tmp3_;
#line 80 "../src/Widgets/ServiceList.vala"
		_tmp3_ = self->priv->housekeeping_item;
#line 80 "../src/Widgets/ServiceList.vala"
		service_item_set_status (_tmp3_, SERVICE_ITEM_STATUS_ENABLED);
#line 155 "ServiceList.c"
	} else {
		SecurityPrivacyHouseKeepingPanel* _tmp4_;
		GraniteSettingsPageStatusType _tmp5_;
		GraniteSettingsPageStatusType _tmp6_;
#line 81 "../src/Widgets/ServiceList.vala"
		_tmp4_ = security_privacy_housekeeping;
#line 81 "../src/Widgets/ServiceList.vala"
		_tmp5_ = granite_settings_page_get_status_type ((GraniteSettingsPage*) _tmp4_);
#line 81 "../src/Widgets/ServiceList.vala"
		_tmp6_ = _tmp5_;
#line 81 "../src/Widgets/ServiceList.vala"
		if (_tmp6_ == GRANITE_SETTINGS_PAGE_STATUS_TYPE_WARNING) {
#line 168 "ServiceList.c"
			ServiceItem* _tmp7_;
#line 82 "../src/Widgets/ServiceList.vala"
			_tmp7_ = self->priv->housekeeping_item;
#line 82 "../src/Widgets/ServiceList.vala"
			service_item_set_status (_tmp7_, SERVICE_ITEM_STATUS_PARTIAL);
#line 174 "ServiceList.c"
		} else {
			SecurityPrivacyHouseKeepingPanel* _tmp8_;
			GraniteSettingsPageStatusType _tmp9_;
			GraniteSettingsPageStatusType _tmp10_;
#line 83 "../src/Widgets/ServiceList.vala"
			_tmp8_ = security_privacy_housekeeping;
#line 83 "../src/Widgets/ServiceList.vala"
			_tmp9_ = granite_settings_page_get_status_type ((GraniteSettingsPage*) _tmp8_);
#line 83 "../src/Widgets/ServiceList.vala"
			_tmp10_ = _tmp9_;
#line 83 "../src/Widgets/ServiceList.vala"
			if (_tmp10_ == GRANITE_SETTINGS_PAGE_STATUS_TYPE_OFFLINE) {
#line 187 "ServiceList.c"
				ServiceItem* _tmp11_;
#line 84 "../src/Widgets/ServiceList.vala"
				_tmp11_ = self->priv->housekeeping_item;
#line 84 "../src/Widgets/ServiceList.vala"
				service_item_set_status (_tmp11_, SERVICE_ITEM_STATUS_DISABLED);
#line 193 "ServiceList.c"
			}
		}
	}
}

void
service_list_add_service (ServiceList* self,
                          ServiceItem* service)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 88 "../src/Widgets/ServiceList.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/Widgets/ServiceList.vala"
	g_return_if_fail (service != NULL);
#line 89 "../src/Widgets/ServiceList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) service);
#line 90 "../src/Widgets/ServiceList.vala"
	_tmp0_ = self->priv->services;
#line 90 "../src/Widgets/ServiceList.vala"
	_tmp1_ = service_item_get_title (service);
#line 90 "../src/Widgets/ServiceList.vala"
	_tmp2_ = _tmp1_;
#line 90 "../src/Widgets/ServiceList.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp2_, service);
#line 220 "ServiceList.c"
}

void
service_list_select_service_name (ServiceList* self,
                                  const gchar* name)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	ServiceItem* _tmp2_;
#line 93 "../src/Widgets/ServiceList.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/Widgets/ServiceList.vala"
	g_return_if_fail (name != NULL);
#line 94 "../src/Widgets/ServiceList.vala"
	_tmp0_ = self->priv->services;
#line 94 "../src/Widgets/ServiceList.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, name);
#line 94 "../src/Widgets/ServiceList.vala"
	_tmp2_ = (ServiceItem*) _tmp1_;
#line 94 "../src/Widgets/ServiceList.vala"
	gtk_list_box_select_row ((GtkListBox*) self, (GtkListBoxRow*) _tmp2_);
#line 94 "../src/Widgets/ServiceList.vala"
	_g_object_unref0 (_tmp2_);
#line 244 "ServiceList.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 30 "../src/Widgets/ServiceList.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 30 "../src/Widgets/ServiceList.vala"
	return _data12_;
#line 254 "ServiceList.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 30 "../src/Widgets/ServiceList.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 264 "ServiceList.c"
		ServiceList* self;
#line 30 "../src/Widgets/ServiceList.vala"
		self = _data12_->self;
#line 30 "../src/Widgets/ServiceList.vala"
		_g_object_unref0 (_data12_->location_item);
#line 30 "../src/Widgets/ServiceList.vala"
		_g_object_unref0 (_data12_->firewall_item);
#line 30 "../src/Widgets/ServiceList.vala"
		_g_object_unref0 (_data12_->privacy_item);
#line 30 "../src/Widgets/ServiceList.vala"
		_g_object_unref0 (self);
#line 30 "../src/Widgets/ServiceList.vala"
		g_slice_free (Block12Data, _data12_);
#line 278 "ServiceList.c"
	}
}

static void
_service_list___lambda31_ (Block12Data* _data12_)
{
	ServiceList* self;
	ServiceItem* _tmp0_;
	SecurityPrivacyFirewallPanel* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 45 "../src/Widgets/ServiceList.vala"
	self = _data12_->self;
#line 46 "../src/Widgets/ServiceList.vala"
	_tmp0_ = _data12_->firewall_item;
#line 46 "../src/Widgets/ServiceList.vala"
	_tmp1_ = security_privacy_firewall;
#line 46 "../src/Widgets/ServiceList.vala"
	_tmp2_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) _tmp1_);
#line 46 "../src/Widgets/ServiceList.vala"
	_tmp3_ = _tmp2_;
#line 46 "../src/Widgets/ServiceList.vala"
	_tmp4_ = gtk_switch_get_active (_tmp3_);
#line 46 "../src/Widgets/ServiceList.vala"
	_tmp5_ = _tmp4_;
#line 46 "../src/Widgets/ServiceList.vala"
	service_list_update_service_status (self, _tmp0_, _tmp5_);
#line 308 "ServiceList.c"
}

static void
__service_list___lambda31__g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
#line 45 "../src/Widgets/ServiceList.vala"
	_service_list___lambda31_ (self);
#line 318 "ServiceList.c"
}

static void
_service_list___lambda32_ (ServiceList* self)
{
#line 52 "../src/Widgets/ServiceList.vala"
	service_list_update_housekeeping_status (self);
#line 326 "ServiceList.c"
}

static void
__service_list___lambda32__g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
#line 51 "../src/Widgets/ServiceList.vala"
	_service_list___lambda32_ ((ServiceList*) self);
#line 336 "ServiceList.c"
}

static void
_service_list___lambda33_ (Block12Data* _data12_)
{
	ServiceList* self;
	ServiceItem* _tmp0_;
	SecurityPrivacyTrackPanel* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 57 "../src/Widgets/ServiceList.vala"
	self = _data12_->self;
#line 58 "../src/Widgets/ServiceList.vala"
	_tmp0_ = _data12_->privacy_item;
#line 58 "../src/Widgets/ServiceList.vala"
	_tmp1_ = security_privacy_tracking;
#line 58 "../src/Widgets/ServiceList.vala"
	_tmp2_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) _tmp1_);
#line 58 "../src/Widgets/ServiceList.vala"
	_tmp3_ = _tmp2_;
#line 58 "../src/Widgets/ServiceList.vala"
	_tmp4_ = gtk_switch_get_active (_tmp3_);
#line 58 "../src/Widgets/ServiceList.vala"
	_tmp5_ = _tmp4_;
#line 58 "../src/Widgets/ServiceList.vala"
	service_list_update_service_status (self, _tmp0_, _tmp5_);
#line 365 "ServiceList.c"
}

static void
__service_list___lambda33__g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
#line 57 "../src/Widgets/ServiceList.vala"
	_service_list___lambda33_ (self);
#line 375 "ServiceList.c"
}

static void
_service_list___lambda34_ (Block12Data* _data12_)
{
	ServiceList* self;
	ServiceItem* _tmp0_;
	SecurityPrivacyLocationPanel* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 65 "../src/Widgets/ServiceList.vala"
	self = _data12_->self;
#line 66 "../src/Widgets/ServiceList.vala"
	_tmp0_ = _data12_->location_item;
#line 66 "../src/Widgets/ServiceList.vala"
	_tmp1_ = security_privacy_location;
#line 66 "../src/Widgets/ServiceList.vala"
	_tmp2_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) _tmp1_);
#line 66 "../src/Widgets/ServiceList.vala"
	_tmp3_ = _tmp2_;
#line 66 "../src/Widgets/ServiceList.vala"
	_tmp4_ = gtk_switch_get_active (_tmp3_);
#line 66 "../src/Widgets/ServiceList.vala"
	_tmp5_ = _tmp4_;
#line 66 "../src/Widgets/ServiceList.vala"
	service_list_update_service_status (self, _tmp0_, _tmp5_);
#line 404 "ServiceList.c"
}

static void
__service_list___lambda34__g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
#line 65 "../src/Widgets/ServiceList.vala"
	_service_list___lambda34_ (self);
#line 414 "ServiceList.c"
}

static GObject *
service_list_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ServiceList * self;
	Block12Data* _data12_;
	ServiceItem* _tmp0_;
	ServiceItem* lock_item = NULL;
	ServiceItem* _tmp1_;
	ServiceItem* _tmp2_;
	ServiceItem* _tmp3_;
	ServiceItem* _tmp4_;
	ServiceItem* _tmp5_;
	ServiceItem* _tmp6_;
	ServiceItem* _tmp7_;
	SecurityPrivacyFirewallPanel* _tmp8_;
	GtkSwitch* _tmp9_;
	GtkSwitch* _tmp10_;
	ServiceItem* _tmp11_;
	SecurityPrivacyTrackPanel* _tmp12_;
	GtkSwitch* _tmp13_;
	GtkSwitch* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	SecurityPrivacyHouseKeepingPanel* _tmp17_;
	SecurityPrivacyTrackPanel* _tmp18_;
	GtkSwitch* _tmp19_;
	GtkSwitch* _tmp20_;
	ServiceItem* _tmp21_;
	ServiceItem* _tmp22_;
	ServiceItem* _tmp23_;
	SecurityPrivacyLocationPanel* _tmp24_;
	GtkSwitch* _tmp25_;
	GtkSwitch* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	SecurityPrivacyLocationPanel* _tmp29_;
	GtkSwitch* _tmp30_;
	GtkSwitch* _tmp31_;
#line 30 "../src/Widgets/ServiceList.vala"
	parent_class = G_OBJECT_CLASS (service_list_parent_class);
#line 30 "../src/Widgets/ServiceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "../src/Widgets/ServiceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERVICE_LIST, ServiceList);
#line 30 "../src/Widgets/ServiceList.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 30 "../src/Widgets/ServiceList.vala"
	_data12_->_ref_count_ = 1;
#line 30 "../src/Widgets/ServiceList.vala"
	_data12_->self = g_object_ref (self);
#line 31 "../src/Widgets/ServiceList.vala"
	_tmp0_ = service_item_new ("document-open-recent", "tracking", _ ("History"));
#line 31 "../src/Widgets/ServiceList.vala"
	g_object_ref_sink (_tmp0_);
#line 31 "../src/Widgets/ServiceList.vala"
	_data12_->privacy_item = _tmp0_;
#line 32 "../src/Widgets/ServiceList.vala"
	_tmp1_ = service_item_new ("system-lock-screen", "locking", _ ("Locking"));
#line 32 "../src/Widgets/ServiceList.vala"
	g_object_ref_sink (_tmp1_);
#line 32 "../src/Widgets/ServiceList.vala"
	lock_item = _tmp1_;
#line 33 "../src/Widgets/ServiceList.vala"
	_tmp2_ = service_item_new ("network-firewall", "firewall", _ ("Firewall"));
#line 33 "../src/Widgets/ServiceList.vala"
	g_object_ref_sink (_tmp2_);
#line 33 "../src/Widgets/ServiceList.vala"
	_data12_->firewall_item = _tmp2_;
#line 34 "../src/Widgets/ServiceList.vala"
	_tmp3_ = service_item_new ("preferences-system-privacy-housekeeping", "housekeeping", _ ("Housekeeping"));
#line 34 "../src/Widgets/ServiceList.vala"
	g_object_ref_sink (_tmp3_);
#line 34 "../src/Widgets/ServiceList.vala"
	_g_object_unref0 (self->priv->housekeeping_item);
#line 34 "../src/Widgets/ServiceList.vala"
	self->priv->housekeeping_item = _tmp3_;
#line 40 "../src/Widgets/ServiceList.vala"
	_tmp4_ = _data12_->privacy_item;
#line 40 "../src/Widgets/ServiceList.vala"
	service_list_add_service (self, _tmp4_);
#line 41 "../src/Widgets/ServiceList.vala"
	_tmp5_ = lock_item;
#line 41 "../src/Widgets/ServiceList.vala"
	service_list_add_service (self, _tmp5_);
#line 42 "../src/Widgets/ServiceList.vala"
	_tmp6_ = _data12_->firewall_item;
#line 42 "../src/Widgets/ServiceList.vala"
	service_list_add_service (self, _tmp6_);
#line 43 "../src/Widgets/ServiceList.vala"
	_tmp7_ = self->priv->housekeeping_item;
#line 43 "../src/Widgets/ServiceList.vala"
	service_list_add_service (self, _tmp7_);
#line 45 "../src/Widgets/ServiceList.vala"
	_tmp8_ = security_privacy_firewall;
#line 45 "../src/Widgets/ServiceList.vala"
	_tmp9_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) _tmp8_);
#line 45 "../src/Widgets/ServiceList.vala"
	_tmp10_ = _tmp9_;
#line 45 "../src/Widgets/ServiceList.vala"
	g_signal_connect_data ((GObject*) _tmp10_, "notify::active", (GCallback) __service_list___lambda31__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 49 "../src/Widgets/ServiceList.vala"
	_tmp11_ = _data12_->privacy_item;
#line 49 "../src/Widgets/ServiceList.vala"
	_tmp12_ = security_privacy_tracking;
#line 49 "../src/Widgets/ServiceList.vala"
	_tmp13_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) _tmp12_);
#line 49 "../src/Widgets/ServiceList.vala"
	_tmp14_ = _tmp13_;
#line 49 "../src/Widgets/ServiceList.vala"
	_tmp15_ = gtk_switch_get_active (_tmp14_);
#line 49 "../src/Widgets/ServiceList.vala"
	_tmp16_ = _tmp15_;
#line 49 "../src/Widgets/ServiceList.vala"
	service_list_update_service_status (self, _tmp11_, _tmp16_);
#line 51 "../src/Widgets/ServiceList.vala"
	_tmp17_ = security_privacy_housekeeping;
#line 51 "../src/Widgets/ServiceList.vala"
	g_signal_connect_object ((GObject*) _tmp17_, "notify::status-type", (GCallback) __service_list___lambda32__g_object_notify, self, 0);
#line 55 "../src/Widgets/ServiceList.vala"
	service_list_update_housekeeping_status (self);
#line 57 "../src/Widgets/ServiceList.vala"
	_tmp18_ = security_privacy_tracking;
#line 57 "../src/Widgets/ServiceList.vala"
	_tmp19_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) _tmp18_);
#line 57 "../src/Widgets/ServiceList.vala"
	_tmp20_ = _tmp19_;
#line 57 "../src/Widgets/ServiceList.vala"
	g_signal_connect_data ((GObject*) _tmp20_, "notify::active", (GCallback) __service_list___lambda33__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 61 "../src/Widgets/ServiceList.vala"
	_tmp21_ = service_item_new ("preferences-system-privacy-location", "location", _ ("Location Services"));
#line 61 "../src/Widgets/ServiceList.vala"
	g_object_ref_sink (_tmp21_);
#line 61 "../src/Widgets/ServiceList.vala"
	_data12_->location_item = _tmp21_;
#line 62 "../src/Widgets/ServiceList.vala"
	_tmp22_ = _data12_->location_item;
#line 62 "../src/Widgets/ServiceList.vala"
	service_list_add_service (self, _tmp22_);
#line 63 "../src/Widgets/ServiceList.vala"
	_tmp23_ = _data12_->location_item;
#line 63 "../src/Widgets/ServiceList.vala"
	_tmp24_ = security_privacy_location;
#line 63 "../src/Widgets/ServiceList.vala"
	_tmp25_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) _tmp24_);
#line 63 "../src/Widgets/ServiceList.vala"
	_tmp26_ = _tmp25_;
#line 63 "../src/Widgets/ServiceList.vala"
	_tmp27_ = gtk_switch_get_active (_tmp26_);
#line 63 "../src/Widgets/ServiceList.vala"
	_tmp28_ = _tmp27_;
#line 63 "../src/Widgets/ServiceList.vala"
	service_list_update_service_status (self, _tmp23_, _tmp28_);
#line 65 "../src/Widgets/ServiceList.vala"
	_tmp29_ = security_privacy_location;
#line 65 "../src/Widgets/ServiceList.vala"
	_tmp30_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) _tmp29_);
#line 65 "../src/Widgets/ServiceList.vala"
	_tmp31_ = _tmp30_;
#line 65 "../src/Widgets/ServiceList.vala"
	g_signal_connect_data ((GObject*) _tmp31_, "notify::active", (GCallback) __service_list___lambda34__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 30 "../src/Widgets/ServiceList.vala"
	_g_object_unref0 (lock_item);
#line 30 "../src/Widgets/ServiceList.vala"
	block12_data_unref (_data12_);
#line 30 "../src/Widgets/ServiceList.vala"
	_data12_ = NULL;
#line 30 "../src/Widgets/ServiceList.vala"
	return obj;
#line 589 "ServiceList.c"
}

static void
service_list_class_init (ServiceListClass * klass,
                         gpointer klass_data)
{
#line 21 "../src/Widgets/ServiceList.vala"
	service_list_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/ServiceList.vala"
	g_type_class_adjust_private_offset (klass, &ServiceList_private_offset);
#line 21 "../src/Widgets/ServiceList.vala"
	G_OBJECT_CLASS (klass)->constructor = service_list_constructor;
#line 21 "../src/Widgets/ServiceList.vala"
	G_OBJECT_CLASS (klass)->finalize = service_list_finalize;
#line 604 "ServiceList.c"
}

static void
service_list_instance_init (ServiceList * self,
                            gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 21 "../src/Widgets/ServiceList.vala"
	self->priv = service_list_get_instance_private (self);
#line 23 "../src/Widgets/ServiceList.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_SERVICE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 23 "../src/Widgets/ServiceList.vala"
	self->priv->services = _tmp0_;
#line 618 "ServiceList.c"
}

static void
service_list_finalize (GObject * obj)
{
	ServiceList * self;
#line 21 "../src/Widgets/ServiceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERVICE_LIST, ServiceList);
#line 22 "../src/Widgets/ServiceList.vala"
	_g_object_unref0 (self->priv->housekeeping_item);
#line 23 "../src/Widgets/ServiceList.vala"
	_g_object_unref0 (self->priv->services);
#line 21 "../src/Widgets/ServiceList.vala"
	G_OBJECT_CLASS (service_list_parent_class)->finalize (obj);
#line 633 "ServiceList.c"
}

static GType
service_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServiceListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) service_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServiceList), 0, (GInstanceInitFunc) service_list_instance_init, NULL };
	GType service_list_type_id;
	service_list_type_id = g_type_register_static (gtk_list_box_get_type (), "ServiceList", &g_define_type_info, 0);
	ServiceList_private_offset = g_type_add_instance_private (service_list_type_id, sizeof (ServiceListPrivate));
	return service_list_type_id;
}

GType
service_list_get_type (void)
{
	static volatile gsize service_list_type_id__once = 0;
	if (g_once_init_enter (&service_list_type_id__once)) {
		GType service_list_type_id;
		service_list_type_id = service_list_get_type_once ();
		g_once_init_leave (&service_list_type_id__once, service_list_type_id);
	}
	return service_list_type_id__once;
}

